SystemOrganization addCategory: #PostgresV2!
SystemOrganization addCategory: #'STON-Core'!

!Time class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:17'!
fromSton: stonReader
	^ self readFrom: stonReader parseListSingleton readStream! !

!Time methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:26'!
stonContainSubObjects 
	^ false! !

!Time methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:03'!
stonOn: stonWriter
	"Use an ISO style HH:MM:SS representation"
	 
	stonWriter writeObject: self listSingleton: 
		(String streamContents: [ :stream |
			self print24: true on: stream ])! !

!String methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:27'!
stonContainSubObjects 
	^ false! !

!String methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 16:22'!
stonOn: stonWriter
	stonWriter writeString: self! !

!DateAndTime class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 19:50'!
fromSton: stonReader
	^ DateAndTime readFrom: stonReader parseListSingleton readStream! !

!DateAndTime methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:25'!
stonContainSubObjects 
	^ false! !

!DateAndTime methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:03'!
stonOn: stonWriter
	"Use an ISO representation with all details"
	
	stonWriter writeObject: self listSingleton: 
		(String streamContents: [ :stream |
			self printOn: stream withLeadingSpace: false ])! !

!Symbol methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 16:22'!
stonOn: stonWriter
	stonWriter writeSymbol: self! !

!TimeStamp class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 13:56'!
fromSton: stonReader
	"We use a representation from DateAndTime"
	
	^ (super fromSton: stonReader) asTimeStamp! !

!Dictionary class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 14:59'!
fromSton: stonReader
	"Instances of STON mapClass will be read directly and won't arrive here.
	Other (sub)classes will use this method."
	
	| dictionary |
	dictionary := self new.
	stonReader parseMapDo: [ :key :value |
		dictionary at: key put: value ].
	^ dictionary! !

!Dictionary methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 14:58'!
stonOn: stonWriter
	"Instances of STON mapClass will be encoded directly, without a class tag.
	Other (sub)classes will be encoded with a class tag and will use a map representation. "
	
	self class == STON mapClass
		ifTrue: [ 
			stonWriter writeMap: self ]
		ifFalse: [ 
			stonWriter 
				writeObject: self 
				do: [ stonWriter encodeMap: self ] ]! !

!Date class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:17'!
fromSton: stonReader
	^ self readFrom: stonReader parseListSingleton readStream! !

!Date methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:26'!
stonContainSubObjects 
	^ false! !

!Date methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:03'!
stonOn: stonWriter
	"Use an ISO style YYYYMMDD representation"
	
	stonWriter writeObject: self listSingleton: self yyyymmdd! !

!Text class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 3/23/2014 18:48'!
fromSton: stonReader
	^ self new
		fromSton: stonReader;
		yourself! !

!Text methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 3/23/2014 18:47'!
fromSton: stonReader
	stonReader parseMapDo: [ :instVarName :value |
		self instVarNamed: instVarName put: value ]! !

!Text methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 3/23/2014 18:47'!
stonOn: stonWriter
	stonWriter writeObject: self! !

Error subclass: #PGUnsupportedAuthentication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

Error subclass: #STONReaderError
	instanceVariableNames: 'streamPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONReaderError commentStamp: '<historical>' prior: 0!
STONReaderError is the error/exception signalled by STONReader when illegal/incorrect input is seen. 
!

!STONReaderError classSide methodsFor: 'instance creation' stamp: 'DamienCassou 12/9/2013 10:04'!
signal: aString streamPosition: streamPosition 
	^ self new
		streamPosition: streamPosition;
		signal: aString;
		yourself! !

!STONReaderError methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 12/13/2013 16:12'!
messageText
	^ streamPosition 
		ifNil: [ 
			super messageText ] 
		ifNotNil: [ :pos | 
			'At character {1}: {2}' format: 
				(Array with: streamPosition with: super messageText) ]! !

!STONReaderError methodsFor: 'accessing' stamp: 'DamienCassou 12/9/2013 10:00'!
streamPosition
	^ streamPosition! !

!STONReaderError methodsFor: 'accessing' stamp: 'DamienCassou 12/9/2013 10:00'!
streamPosition: aNumber
	streamPosition := aNumber! !

Error subclass: #STONWriterError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONWriterError commentStamp: 'SvenVanCaekenberghe 4/26/2012 17:17' prior: 0!
STONWriterError is the error/exception signalled by STONWriter when illegal/incorrect input is seen. !

!UndefinedObject methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:27'!
stonContainSubObjects 
	^ false! !

!UndefinedObject methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 15:54'!
stonOn: stonWriter
	stonWriter writeNull! !

!Collection class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 13:54'!
fromSton: stonReader
	| collection |
	collection := self new.
	stonReader parseListDo: [ :each |
		collection add: each ].
	^ collection! !

!Collection methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
stonOn: stonWriter
	stonWriter writeObject: self do: [
		stonWriter encodeList: self ]
! !

!Point methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 14:30'!
fromSton: stonReader
	stonReader parseListDo: [ :each :index |
		index = 1 ifTrue: [ x := each ].
		index = 2 ifTrue: [ y := each ] ]! !

!Point methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/24/2012 10:02'!
stonOn: stonWriter
	stonWriter writeObject: self streamShortList: [ :array |
		array add: x; add: y ]! !

!Integer methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 15:47'!
stonOn: stonWriter
	stonWriter writeInteger: self! !

!Character class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:17'!
fromSton: stonReader
	^ stonReader parseListSingleton first! !

!Character methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:02'!
stonOn: stonWriter
	stonWriter writeObject: self listSingleton: self asString! !

!Number methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:26'!
stonContainSubObjects 
	^ false! !

!Number methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 17:26'!
stonOn: stonWriter
	stonWriter writeFloat: self asFloat! !

!SmallDictionary class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 9/17/2013 19:50'!
fromSton: stonReader
	"My instances are stored as maps."
	
	| dictionary |
	dictionary := self new.
	stonReader parseMapDo: [ :key :value |
		dictionary at: key put: value ].
	^ dictionary! !

!SmallDictionary methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 9/17/2013 20:13'!
stonOn: stonWriter
	"I store my instances as maps"
	
	stonWriter 
		writeObject: self 
		do: [ stonWriter encodeMap: self ]! !

TestCase subclass: #TestPGConnection
	instanceVariableNames: 'useConnectionDefaults notificationSubscriberCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!TestPGConnection methodsFor: 'private' stamp: 'yj 11/10/2004 23:32'!
asFloat8Arg: aFloat
	"Convert aFloat to a ByteArray for use as a function call argument."

	| word1 word2 bigEndian arg tmp |

	word1 := aFloat basicAt: 1.
	word2 := aFloat basicAt: 2.
	bigEndian := false.
	bigEndian ifTrue: [
			tmp := word1.
			word1 := word2.
			word2 := tmp.
		].
	arg := ByteArray new: 8.
	arg at: 1 put: ((word1 bitShift: -24) bitAnd: 16rFF).
	arg at: 2 put: ((word1 bitShift: -16) bitAnd: 16rFF).
	arg at: 3 put: ((word1 bitShift: -8) bitAnd: 16rFF).
	arg at: 4 put: ((word1 bitShift: 0) bitAnd: 16rFF).
	arg at: 5 put: ((word2 bitShift: -24) bitAnd: 16rFF).
	arg at: 6 put: ((word2 bitShift: -16) bitAnd: 16rFF).
	arg at: 7 put: ((word2 bitShift: -8) bitAnd: 16rFF).
	arg at: 8 put: ((word2 bitShift: 0) bitAnd: 16rFF).
	^ arg
! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 2/9/2005 21:51'!
asFloat8ArgVW: aFloat
	"Convert aFloat to a ByteArray for use as a function call argument."

	| arg |
	arg := ByteArray new: 8.
	1 to: 8 do: [:i | arg at: i put: (aFloat basicAt: 8 - i + 1)].
	^arg! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 4/24/2003 23:01'!
copy: sql withStream: aStream

	| conn |
	conn := self newConnection.
	conn startup.
	conn copy: sql withStream: aStream.
	conn terminate.! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
createTestCopyInOutTable

	self executeAll: #(
			'CREATE TABLE TestCopyInOutTable (
				id integer,
				name text
			)'
		).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
createTestFieldConverterTable

	self executeAll: #(
'CREATE TABLE TestFieldConverterTable (
aBool1 boolean,
aBool2 boolean,
aChar char,
aChar1 char(1),
aChar2 char(2),
anInt2 int2,
anInt4 int4,
anInt8 int8,
aFloat4 float4,
aFloat8 float8,
aNumeric numeric,
aDate date,
aTime time,
aText text
)'
		).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
createTestTable

	self executeAll: #(
			'CREATE TABLE products (
				product_no integer,
				name text,
				price numeric
			)'
		).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
dropTestCopyInOutTable

	self executeAll: #(
			'DROP TABLE TestCopyInOutTable'
		).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
dropTestFieldConverterTable

	self executeAll: #(
			'DROP TABLE TestFieldConverterTable'
		).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
dropTestTable

	self executeAll: #(
			'DROP TABLE products'
		).
! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 4/24/2003 23:01'!
execute: sql on: conn

	| result resultStream |

	resultStream := ReadWriteStream on: String new.
	result := conn execute: sql.
	result displayResultOn: resultStream.
	^ resultStream contents.
! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 4/24/2003 23:01'!
executeAll: queries

	self executeAll: queries withDelayForMilliseconds: nil! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 4/24/2003 23:01'!
executeAll: queries withDelayForMilliseconds: millisecondDelay

	| conn result |

	conn := self newConnection.
	conn startup.
	queries do: [:each |
		Transcript nextPutAll: 'QUERY: '; nextPutAll: each; cr; flush.
		result := conn execute: each.
		result displayResultOn: Transcript.
		Transcript flush.
		millisecondDelay isNil ifFalse: [
			Transcript nextPutAll: 'Delaying for ', millisecondDelay printString, ' ms...'; cr.
			(Delay forMilliseconds: millisecondDelay) wait.
			Transcript flush.
		].
	].
	conn terminate.! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 11/10/2004 23:52'!
floatFromByteArray: aByteArray
	"Convert aByteArray to a Float."

	| word1 word2 aFloat |

	word1 := (aByteArray at: 1) bitShift: 24.
	word1 := word1 bitOr: ((aByteArray at: 2) bitShift: 16).
	word1 := word1 bitOr: ((aByteArray at: 3) bitShift: 8).
	word1 := word1 bitOr: ((aByteArray at: 4) bitShift: 0).
	word2 := (aByteArray at: 5) bitShift: 24.
	word2 := word2 bitOr: ((aByteArray at: 6) bitShift: 16).
	word2 := word2 bitOr: ((aByteArray at: 7) bitShift: 8).
	word2 := word2 bitOr: ((aByteArray at: 8) bitShift: 0).

	aFloat := 0.0.
	aFloat basicAt: 1 put: word1.
	aFloat basicAt: 2 put: word2.
	^aFloat! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 2/9/2005 21:59'!
floatFromByteArrayVW: aByteArray
	"Convert aByteArray to a Float."

	| aFloat |
	aFloat := ByteArray new: 8.
	1 to: 8 do: [:i | aFloat at: 8 - i + 1 put: (aByteArray at: i)].
	aFloat changeClassTo: Double.
	^aFloat! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 4/24/2003 23:01'!
functionCall: oid arguments: arguments

	| conn result |
	conn := self newConnection.
	conn startup.
	result := conn functionCall: oid arguments: arguments.
	conn terminate.
	^ result
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
makeCopyInOutEos
	"Answer the COPY IN/OUT end of stream code."

	^ String with: $\ with: $.with: Character lf
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
makeCopyInOutLine: aCollection

	| ws |
	ws := WriteStream on: (String new: 512).
	aCollection withIndexDo: [:each :i |
		ws nextPutAll: each.
		i < aCollection size ifTrue: [ws tab]
	].
	ws nextPut: Character lf.
	^ ws contents.
! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 4/24/2003 23:01'!
newConnection

	| conn |

	conn := PGConnection new.
	(useConnectionDefaults isNil or: [useConnectionDefaults not])
		ifTrue: [ conn connectionArgs: PGConnection buildDefaultConnectionArgs ]
		ifFalse: [ PGConnection defaultConnectionArgs: nil. conn connectionArgs: nil ].
	(notificationSubscriberCount notNil and: [notificationSubscriberCount > 0 ])
		ifTrue: [
			1 to: notificationSubscriberCount do: [:i |
				conn addNotificationSubscriber: PGNotificationSubscriber new]
		].
	^ conn
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
oidAbs
	"oid 1395 is abs(float8)"
	^ 1395
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
oidSqrt
	"oid 1344 is sqrt(float8)"
	^ 1344
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
oidTimenow

	^ 250
! !

!TestPGConnection methodsFor: 'postgres test suite' stamp: 'yj 4/24/2003 23:01'!
regress: testName

	| inStream conn outStream line pos result sql |

	Transcript show: testName, '--starting test'; cr.
	conn := self newConnection.
	conn startup.

	inStream := FileStream readOnlyFileNamed: 'u:\lib\pgsql\test\regress\sql\', testName, '.sql'.
	outStream := FileStream newFileNamed: testName, '.out'.
	sql := ''.
	[inStream atEnd] whileFalse: [
		line := inStream upTo: Character lf.
		(line beginsWith: '--')
			ifTrue: [outStream nextPutAll: line; cr].
		(line size > 0 and: [(line beginsWith: '--') not]) ifTrue: [
			pos := line findString: '\g'. "\g is psql execute command"
			pos > 0 ifTrue: [line := line copyFrom: 1 to: pos - 1].
			sql := sql, line, String cr.
			(line endsWith: ';') ifTrue: [
				result := conn execute: sql.
				Transcript show: sql; flush.
				outStream nextPutAll: sql.
				result displayResultOn: outStream.
				sql := ''.
			].
		].
	].
	inStream close.
	outStream close.

	conn terminate.
	Transcript show: testName, '--test completed'; cr.
! !

!TestPGConnection methodsFor: 'postgres test suite' stamp: 'yj 4/24/2003 23:01'!
regressionTestNames

	^#(
		#('boolean' 'char' 'name' 'varchar' 'text' 'int2' 'int4' 'int8' 'oid' 'float4' 'float8' 'numeric')
		'strings'
		'numerology'
		#('point' 'lseg' 'box' 'path' 'polygon' 'circle' 'interval' 'timestamp' 'reltime' 'tinterval' 'inet' 'comments' 'oidjoins' 'type_sanity' 'opr_sanity')
		'abstime'
		'geometry'
		'horology'
		'create_function_1'
		'create_type'
		'create_table'
		'create_function_2'
		'copy'
		#('constraints' 'triggers' 'create_misc' 'create_aggregate' 'create_operator' 'create_index')
		'create_view'
		'sanity_check'
		'errors'
		'select'
		#('select_info' 'select_distinct' 'select_distinct_on' 'select_implicit' 'select_having' 'subselect' 'union' 'case' 'join' 'aggregates' 'transactions' 'random' 'portals' 'arrays' 'btree_index' 'hash_index')
		'misc'
		#('select_views' 'alter_table' 'portals_p2' 'rules' 'foreign_key')
		#('limit' 'plpgsql' 'temp')
	)! !

!TestPGConnection methodsFor: 'postgres test suite' stamp: 'yj 4/24/2003 23:01'!
runRegressionTests
	"TestPGConnection new runRegressionTests"

	self regress: 'drop'.
	(self regressionTestNames at: 1) do: [:each | self regress: each].
	"self regressionTestNames do: [:test |
		test isString
			ifTrue: [self regress: test]
			ifFalse: [test do: [:each | self regress: each]]
	]."
! !

!TestPGConnection methodsFor: 'private' stamp: 'yj 4/24/2003 23:01'!
tearDown

	PGConnection defaultConnectionArgs: nil.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testCancelRequest
	"Test: CancelRequest.

	Set the debug level of the postmaster daemon to 1 or greater.
	Capture the postmaster output in a log file.
	Examine the log file for a cancel request with a matching process id.

	Example, an init.d script containing:
		su -l postgres -s /bin/sh -c ""/usr/bin/pg_ctl  -D $PGDATA -p /usr/bin/postmaster -o '-i -d 1' start  > /var/log/postgresql/log 2>&1"" < /dev/null
	yields a line in the log:
		/usr/bin/postmaster: processCancelRequest: sending SIGINT to process 13142
	"

	| conn |

	conn := self newConnection.
	conn startup.
	conn cancelRequest.
	conn terminate.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testConnection
	"Test: connect and disconnect, without any queries."

	self executeAll: #().
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testCopyIn1

	| ws conn result |
	ws := WriteStream on: String new.
	ws nextPutAll: self makeCopyInOutEos.

	self dropTestCopyInOutTable.
	self createTestCopyInOutTable.

	conn := self newConnection.
	conn startup.
	conn copy: 'copy TestCopyInOutTable from stdin' withStream: ws.
	result := conn execute: 'select * from TestCopyInOutTable'.
	conn terminate.

	self assert: result rows size = 0.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testCopyIn2

	| ws result conn |

	self dropTestCopyInOutTable.
	self createTestCopyInOutTable.

	ws := WriteStream on: String new.
	ws nextPutAll: (self makeCopyInOutLine: (Array with: '77' with: 'abcde')).
	ws nextPutAll: self makeCopyInOutEos.

	conn := self newConnection.
	conn startup.
	conn copy: 'copy TestCopyInOutTable from stdin' withStream: ws.
	result := conn execute: 'select * from TestCopyInOutTable'.
	conn terminate.
	self assert: result rows size = 1.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testCopyOut1

	| ws |
	self dropTestCopyInOutTable.
	self createTestCopyInOutTable.
	ws := WriteStream on: (String new: 512).
	self copy: 'copy TestCopyInOutTable to stdout' withStream: ws.
	"Transcript show: ws contents printString; cr."
	self assert: ws contents = (String with: $\ with: $. with: Character lf).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testCopyOut2

	| ws rs |

	ws := WriteStream on: String new.
	ws nextPutAll: (self makeCopyInOutLine: (Array with: '77' with: 'abcde')).
	ws nextPutAll: self makeCopyInOutEos.

	self dropTestCopyInOutTable.
	self createTestCopyInOutTable.
	self executeAll: #('insert into TestCopyInOutTable values(77,''abcde'')').

	rs := WriteStream on: (String new: 512).
	self copy: 'copy TestCopyInOutTable to stdout' withStream: rs.

	self assert: rs contents = ws contents.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testCopyOut3

	| ws rs |

	ws := WriteStream on: String new.
	ws nextPutAll: (self makeCopyInOutLine: (Array with: '77' with: 'abcde')).
	ws nextPutAll: (self makeCopyInOutLine: (Array with: '88' with: 'vwxyz')).
	ws nextPutAll: self makeCopyInOutEos.

	self dropTestCopyInOutTable.
	self createTestCopyInOutTable.
	self executeAll: #('insert into TestCopyInOutTable values(77,''abcde'')').
	self executeAll: #('insert into TestCopyInOutTable values(88,''vwxyz'')').

	rs := WriteStream on: (String new: 512).
	self copy: 'copy TestCopyInOutTable to stdout' withStream: rs.

	self assert: rs contents = ws contents.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testExecute1

	self executeAll: #(
			'select timenow()'
			'select abs(-1)'
		).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testExecute2

	self executeAll: #(
			'select timenow(); select abs(-1)'
		).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testExecuteUsingConnectionDefaults

	useConnectionDefaults := true.
	self executeAll: #(
			'select timenow()'
			'select abs(-1)'
		).
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testFieldConverter
	"Test: two different connections can have a different field converter for a given typeOid.

	This capability would be useful when using one image to connect to two different databases,
	where the same (custom) typeOid is defined differently in each database.
	"

	| conn1 result1 conn2 result2 newConverter |

	self dropTestTable.
	self createTestTable.

	conn1 := self newConnection.
	conn2 := self newConnection.
	conn1 startup.
	conn2 startup.

	result1 := conn1 execute: 'INSERT INTO products VALUES (1);'.
	result1 := conn1 execute: 'select * from products'.

	newConverter := [:value | value].
	conn2 fieldConverterAt: 20 put: newConverter.
	conn2 fieldConverterAt: 21 put: newConverter.
	conn2 fieldConverterAt: 23 put: newConverter.
	result2 := conn2 execute: 'select * from products'.

	conn1 terminate.
	conn2 terminate.

	self assert: result1 rows size = 1.
	self assert: result1 rows first data first = 1.

	self assert: result2 rows size = 1.
	self assert: result2 rows first data first = '1'.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 2/1/2006 11:37'!
testFieldConverter2

	| conn result data |

	self dropTestFieldConverterTable.
	self createTestFieldConverterTable.

	conn := self newConnection.
	conn startup.
	result := conn execute:
'INSERT INTO TestFieldConverterTable VALUES (TRUE,FALSE,''A'',''B'',''CD'',77,88,99,11.11,22.22,33.33,''2001-01-01'',''04:05:06'',''abcd'');'.
	result := conn execute: 'select * from TestFieldConverterTable'.
	conn terminate.

	self assert: result rows size = 1.
	data := result rows first data.
	"result rows first inspect."
	self assert: (data at: 1).
	self assert: (data at: 2) not.
	self assert: (data at: 3) = 'A'.
	self assert: (data at: 4) = 'B'.
	self assert: (data at: 5) = 'CD'.
	self assert: (data at: 6) = 77.
	self assert: (data at: 7) = 88.
	self assert: (data at: 8) = 99.
	self assert: ((data at: 9) - 11.11) abs < 0.0001.
	self assert: ((data at: 10) - 22.22) abs < 0.0001.
	self assert: ((data at: 11) - 33.33) abs < 0.0001.
	"self assert: (data at: 12) = (DateAndTime year: 2001 month: 1 day: 1 hour: 0 minute: 0 second: 0)."
	self assert: (data at: 12) = (Date newDay: 1 month: 1 year: 2001).
	self assert: (data at: 13) = (Time fromSeconds: (4*60*60) + (5*60) + 6).
	self assert: (data at: 14) = 'abcd'.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 2/1/2006 11:37'!
testFieldConverter3

	| conn result d |

	self dropTestFieldConverterTable.
	self createTestFieldConverterTable.

	conn := self newConnection.
	conn startup.
	result := conn execute:
'INSERT INTO TestFieldConverterTable VALUES (TRUE,FALSE,''A'',''B'',''CD'',77,88,99,11.11,22.22,33.33,''2001-01-01'',''04:05:06'',''abcd'');'.
	result := conn execute: 'select * from TestFieldConverterTable'.
	conn terminate.

	self assert: result rows size = 1.
	d := result rows first dataKeyedByFieldName.
	"result rows first inspect."
	self assert: (d at: 'aBool1' asLowercase).
	self assert: (d at: 'aBool2' asLowercase) not.
	self assert: (d at: 'aChar' asLowercase) = 'A'.
	self assert: (d at: 'aChar1' asLowercase) = 'B'.
	self assert: (d at: 'aChar2' asLowercase) = 'CD'.
	self assert: (d at: 'anInt2' asLowercase) = 77.
	self assert: (d at: 'anInt4' asLowercase) = 88.
	self assert: (d at: 'anInt8' asLowercase) = 99.
	self assert: ((d at: 'aFloat4' asLowercase) - 11.11) abs < 0.0001.
	self assert: ((d at: 'aFloat8' asLowercase) - 22.22) abs < 0.0001.
	self assert: ((d at: 'aNumeric' asLowercase) - 33.33) abs < 0.0001.
	"self assert: (d at: 'aDate' asLowercase) = (DateAndTime year: 2001 month: 1 day: 1 hour: 0 minute: 0 second: 0)."
	self assert: (d at: 'aDate' asLowercase) = (Date newDay: 1 month: 1 year: 2001).
	self assert: (d at: 'aTime' asLowercase) = (Time fromSeconds: (4*60*60) + (5*60) + 6).
	self assert: (d at: 'aText' asLowercase) = 'abcd'.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testFunctionCall
	"Test: make several function calls before terminating."

	| conn result arg |
	arg := self asFloat8Arg: 1.0.
	conn := self newConnection.
	conn startup.
	result := conn functionCall: self oidTimenow arguments: OrderedCollection new.
	result := conn functionCall: self oidAbs arguments: (OrderedCollection with: arg).
	result := conn functionCall: self oidSqrt arguments: (OrderedCollection with: arg).
	conn terminate.
	^ result
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testFunctionCall1

	| result |
	result := self functionCall: self oidTimenow arguments: OrderedCollection new.
	self assert: result functionResult notNil.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 11/10/2004 23:52'!
testFunctionCall2

	| arg result |
	arg := self asFloat8Arg: -1.0.
	result :=  self functionCall: self oidAbs arguments: (OrderedCollection with: arg).
	self assert: result functionResult notNil.
	self assert: (self floatFromByteArray: result functionResult result) = 1.0.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 11/10/2004 23:54'!
testFunctionCall3

	| arg result |
	arg := self asFloat8Arg: 1.0.
	result := self functionCall: self oidSqrt arguments: (OrderedCollection with: arg).
	self assert: result functionResult notNil.
	self assert: (self floatFromByteArray: result functionResult result) = 1.0.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testNotify1

	notificationSubscriberCount := 1.

	[
		self executeAll: #(
			'notify pgtest' 'notify pgtest' 'notify pgtest' 'notify pgtest' 'notify pgtest'
			'notify pgtest' 'notify pgtest' 'notify pgtest' 'notify pgtest' 'notify pgtest'
		) withDelayForMilliseconds: 1000
	] fork.

	self executeAll: #(
		'listen pgtest'
		'select timenow()'
		'select timenow()'
	) withDelayForMilliseconds: 5000
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testNotify2
	"Test: a NoticeResponse will be sent because there is an extra field on the input line."

	| ws conn |

	notificationSubscriberCount := 2.

	self dropTestTable.
	self createTestTable.

	ws := WriteStream on: String new.
	ws nextPutAll: (self makeCopyInOutLine: (Array with: '77' with: 'abcde' with: '123.456' with: '999.999')).
	ws nextPutAll: self makeCopyInOutEos.

	conn := self newConnection.
	conn startup.
	conn copy: 'copy products from stdin' withStream: ws.
	conn terminate.
! !

!TestPGConnection methodsFor: 'as yet unclassified' stamp: 'noha 11/26/2007 16:58'!
testReadWriteWithEncoding

	| conn1 result1 |
	self dropTestTable.
	self createTestTable.

	conn1 := self newConnection.
	conn1 connectionArgs clientEncoding: #utf8.
	conn1 startup.

	result1 := conn1 execute: 'INSERT INTO products VALUES (1, '''');'.
	result1 := conn1 execute: 'select * from products'.

	conn1 terminate.

	self assert: result1 rows size = 1.
	self assert: result1 rows first data second = ''.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testResultSet1

	| conn result |

	self dropTestTable.
	self createTestTable.

	conn := self newConnection.
	conn startup.
	result := conn execute: 'insert into products values(77,''abcde'',123.456)'.
	result := conn execute: 'select * from products'.
	conn terminate.

	self assert: result rows size = 1.
! !

!TestPGConnection methodsFor: 'tests' stamp: 'yj 4/24/2003 23:01'!
testResultSet2

	| conn result rs1 rs2 |

	self dropTestTable.
	self createTestTable.

	conn := self newConnection.
	conn startup.
	result := conn execute: 'insert into products values(49,''abcde'',123.456)'.
	result := conn execute: 'insert into products values(50,''abcde'',123.456)'.
	result := conn execute: 'insert into products values(51,''abcde'',123.456)'.
	result := conn execute: 'insert into products values(52,''abcde'',123.456)'.
	result := conn execute: 'select * from products; select * from products where product_no > 50'.
	conn terminate.

	rs1 := result resultSets at: 1.
	self assert: rs1 rows size = 4.

	rs2 := result resultSets at: 2.
	self assert: rs2 rows size = 2.
! !

TestCase subclass: #TestPGDateAndTimeExtension
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!TestPGDateAndTimeExtension methodsFor: 'tests' stamp: 'YanniChiu 2/4/2011 22:52'!
testYearMonthDayInstanceCreation
	"#year:month:day: shortcuts #year:month:day:hour:minute:second:,
	but it should not forget about the offset.
	This test will fail to detect a problem if run where the local timezone offset is 0."
	| year month day date1 date2 |
	year := 2011.
	month := 2.
	day := 4.
	date1 := DateAndTime year: year month: month day: day hour: 0 minute: 0 second: 0.
	date2 := DateAndTime year: year month: month day: day.
	self assert: date1 = date2! !

!Boolean methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:24'!
stonContainSubObjects 
	^ false! !

!Boolean methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/14/2012 15:53'!
stonOn: stonWriter
	stonWriter writeBoolean: self! !

!Class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:06'!
stonName
	"Override to encode my instances using a different class name."
	
	^ self name! !

!ByteArray class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:16'!
fromSton: stonReader
	^ self readHexFrom: stonReader parseListSingleton! !

!ByteArray methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:25'!
stonContainSubObjects 
	^ false! !

!ByteArray methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 20:02'!
stonOn: stonWriter
	"Use a hex representation"
	
	stonWriter writeObject: self listSingleton: self hex! !

!RunArray class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 3/23/2014 18:51'!
fromSton: stonReader
	^ self new
		fromSton: stonReader;
		yourself! !

!RunArray methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 3/23/2014 18:52'!
fromSton: stonReader
	stonReader parseMapDo: [ :instVarName :value |
		self instVarNamed: instVarName put: value ]! !

!RunArray methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 3/23/2014 18:52'!
stonOn: stonWriter
	stonWriter writeObject: self! !

!SequenceableCollection class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 15:07'!
fromSton: stonReader
	^ self streamContents: [ :stream |
		stonReader parseListDo: [ :each |
			stream nextPut: each ] ]! !

!SequenceableCollection methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/8/2012 19:22'!
stonOn: stonWriter
	self class == STON listClass
		ifTrue: [ stonWriter writeList: self ]
		ifFalse: [ super stonOn: stonWriter ]! !

!Object class methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 2/12/2012 19:58'!
fromSton: stonReader
	"Create a new instance and delegate decoding to instance side.
	Override only when new instance should be created directly (see implementors). "
	
	^ self new
		fromSton: stonReader;
		yourself! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 3/23/2014 19:31'!
fromSton: stonReader
	"Decode non-variable classes from a map of their instance variables and values.
	Override to customize and add a matching #toSton: (see implementors)."
	
	self class isVariable 
		ifTrue: [
			self subclassResponsibility ]
		ifFalse: [
			stonReader parseMapDo: [ :instVarName :value |
				self instVarNamed: instVarName put: value ] ]
! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 1/18/2012 20:16'!
isStonReference
	^ false! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:24'!
stonContainSubObjects
	"Return true if I contain subObjects that should be processed, false otherwise.
	Overwrite when necessary. See also #stonProcessSubObjects:"
	
	^ true! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/28/2012 14:27'!
stonOn: stonWriter
	"Encode non-variable classes with a map of their instance variable and values.
	Override to customize and add a matching #fromSton: (see implementors)."

	self class isVariable 
		ifTrue: [
			self subclassResponsibility ]
		ifFalse: [
			stonWriter writeObject: self ]
! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/29/2012 16:22'!
stonProcessSubObjects: block
	"Execute block to (potentially) change each of my subObjects.
	In general, all instance and indexable variables are processed.
	Overwrite when necessary. Not used when #stonContainSubObjects returns false."
	
	1 to: self class instSize do: [ :each |
		self instVarAt: each put: (block value: (self instVarAt: each)) ].
	(self class isVariable and: [ self class isBytes not ])
		ifTrue: [
			1 to: self basicSize do: [ :each |
				self basicAt: each put: (block value: (self basicAt: each)) ] ]! !

!Object methodsFor: '*ston-core' stamp: 'SvenVanCaekenberghe 11/13/2013 23:43'!
stonShouldWriteNilInstVars
	"Return true if my instance variables that are nil should be written out, 
	false otherwise. Overwrite when necessary. By default, return false."
	
	^ false! !

Object subclass: #PGActiveObject
	instanceVariableNames: 'trace state events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

PGActiveObject class
	instanceVariableNames: 'stateTransitionTable'!

PGActiveObject class
	instanceVariableNames: 'stateTransitionTable'!

!PGActiveObject class methodsFor: 'stt' stamp: 'kb 1/30/2009 20:07'!
buildStateTransitionTable

	^IdentityDictionary new
! !

!PGActiveObject class methodsFor: 'stt' stamp: 'yj 4/24/2003 23:01'!
resetStateTransitionTable

	stateTransitionTable := nil
! !

!PGActiveObject class methodsFor: 'stt' stamp: 'yj 4/24/2003 23:01'!
stateTransitionTable

	stateTransitionTable == nil ifTrue: [stateTransitionTable := self buildStateTransitionTable].
	^ stateTransitionTable
! !

!PGActiveObject methodsFor: 'private-sa' stamp: 'yj 4/24/2003 23:01'!
generateEvent: event to: receiver

	^self == receiver
		ifTrue: [self processEvent: event]
		ifFalse: [receiver queueEvent: event].
! !

!PGActiveObject methodsFor: 'initialize/release' stamp: 'yj 4/24/2003 23:01'!
initialize

	state := #Created.
	events := OrderedCollection new.
	^self
! !

!PGActiveObject methodsFor: 'trace' stamp: 'yj 4/24/2003 23:01'!
log: where text: text

	self logInfo: where, ': ', text.
! !

!PGActiveObject methodsFor: 'trace' stamp: 'yj 4/24/2003 23:01'!
logIdString

	^ self class name, '(', self hash printString, ')'.
! !

!PGActiveObject methodsFor: 'trace' stamp: 'yj 4/24/2003 23:01'!
logInfo: text

	Transcript
		nextPut: $[;
		nextPutAll: self logIdString;
		nextPut: $];
		space;
		nextPutAll: text;
		cr;
		flush.
! !

!PGActiveObject methodsFor: 'private-sa' stamp: 'yj 4/24/2003 23:01'!
nextEvent

	^ #CantHappen
! !

!PGActiveObject methodsFor: 'private-sa' stamp: 'yj 11/12/2004 18:20'!
processEvent: event

	| nextState eventName eventNameString traceText |

	eventName := event isSymbol ifTrue: [event] ifFalse: [event eventName].
	nextState := (self stateTransitionTable at: state)
		at: eventName
		ifAbsent: [ #CantHappen ].

	trace >= 8 ifTrue: [
		eventNameString := event isSymbol ifTrue: [event asString] ifFalse: [event eventName].
		traceText := nextState = #EventIgnored
			ifTrue: [ state asString, ' IGNORE ', eventNameString ]
			ifFalse: [ state asString, '-->', nextState asString, ' on ', eventNameString ].
		self log: 'processEvent' text: traceText.
	].

	nextState = #EventIgnored
		ifFalse: [
			state := nextState.
			self perform: ('st', state asString, ':') asSymbol with: event.
		].
! !

!PGActiveObject methodsFor: 'private-sa' stamp: 'yj 4/24/2003 23:01'!
queueEvent: event

	events addLast: event.
! !

!PGActiveObject methodsFor: 'private-sa' stamp: 'yj 4/24/2003 23:01'!
saProcessEventsUntil: newStates

	[
		[events size > 0] whileTrue: [
			self processEvent: events removeFirst.
		].
		(newStates includes: state) 
			ifFalse: [self generateEvent: self nextEvent to: self].
		(newStates includes: state) not
	] whileTrue.
! !

!PGActiveObject methodsFor: 'private-sa' stamp: 'yj 4/24/2003 23:01'!
stCantHappen: event
	"Handle a defective state machine."

	self error: self class name, ' has a defective state machine'.
! !

!PGActiveObject methodsFor: 'private-sa' stamp: 'yj 4/24/2003 23:01'!
stateTransitionTable

	^ self class stateTransitionTable
! !

!PGActiveObject methodsFor: 'trace' stamp: 'yj 4/24/2003 23:01'!
trace
	^trace! !

!PGActiveObject methodsFor: 'trace' stamp: 'yj 4/24/2003 23:01'!
trace: anInteger
	trace := anInteger! !

PGActiveObject subclass: #PGConnection
	instanceVariableNames: 'socket readBuffer readIndex lastReadIndex writeBuffer processId secretKey sql functionCallOid functionCallArgs copyStream result connectionArgs notificationSubscribers fieldConverters sqlStringConverter receivingTextConverter'
	classVariableNames: 'DefaultConnectionArgs DefaultTraceLevel'
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGConnection commentStamp: 'TudorGirba 3/3/2014 07:29' prior: 0!
Instances of PGConnection implement a client interface to a PostgreSQL backend.
See the "Frontend/Backend Protocol" chapter in the "PostgreSQL Programmer's Guide" for more information.


!!License
Oringinally created by  in 2001-2003. Released under MIT.

Copyright (c) 2001-2003 Yanni Chiu

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.!

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 02:41'!
booleanArrayConverter

	^[ :s | 
		| readStream |
		readStream := s readStream.
		readStream next.
		Array streamContents: [ :stream | 
			[ readStream atEnd or: [ readStream peek = $} ] ] whileFalse: [
				stream nextPut: (self nextBooleanFrom: readStream) ] ] ].

! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 02:41'!
booleanConverter

	^[ :s | s = 't' or: [ s = 'T' ] ]! !

!PGConnection class methodsFor: 'initialization' stamp: 'GuillermoPolito 5/9/2014 14:02'!
buildDefaultConnectionArgs

	^ PGConnectionArgs
		hostname: 'localhost'
		portno: 5432
		databaseName: 'sodbxtest'
		userName: 'sodbxtest'
		password: 'sodbxtest'
! !

!PGConnection class methodsFor: 'initialization' stamp: 'kb 1/31/2009 07:03'!
buildDefaultFieldConverters
	"The type oid's can be found using:
		SELECT oid,typname from pg_type
	Also, see the source code file:
		.../src/include/catalog/pg_type.h
	"
	| converters |
	converters := IdentityDictionary new.
	#(
		(booleanConverter (16 "boolean"))
		(booleanArrayConverter (1000 "boolean[]"))
		(characterConverter (18 "char" 1002 "_char" 1042 "bpchar")) "fix the array converter!!"
		(integerConveter (20 "int8" 21 "int2" 23 "int4"))
		(integerArrayConveter (1005 "_int2[]" 1007 "_int4[]" 1016 "_int8[]"))
		(stringArrayConveter (1009)) "doesn't handle nulls"
		(floatConverter (700 "float4" 701 "float8" 1021 "_float4" 1022 "_float8")) "fix the array converter"
		(numericConverter (1700 "numeric")) "fix it, it returns a float now"
		(dateConverter (1082 "date" 1182 "_date")) "fix the array converter"
		(timeConverter (1083 "time" 1183 "_time")) "fix the array converter"
		(timestampConverter (1114 "timestamp" 1115 "_timestamp")) "fix the array converter"
		(timeWithTimezoneConverter (1266 "timetz" 1270 "_timetz")) "probably omits the timezone. fix the array converter"
		(timestampWithTimezoneConverter (1184 "timestamptz " 1185 "_timestamptz")) "fix the array converter"
	) do: [ :each |
		each second do: [ :typeOid |
			converters at: typeOid put: (self perform: each first) ] ].
	^ converters
! !

!PGConnection class methodsFor: 'initialization' stamp: 'kb 1/30/2009 20:08'!
buildStateTransitionTable
	"self resetStateTransitionTable"

	^#(
	(Created (
		(Startup Startup)))
	(Startup (
		(AuthenticationKerberosV4 UnsupportedAuthentication)
		(AuthenticationKerberosV5 UnsupportedAuthentication)
		(AuthenticationCleartextPassword SendingCleartextPassword)
		(AuthenticationCryptPassword UnsupportedAuthentication)
		(AuthenticationMD5Password	SendingMD5Password)
		(AuthenticationSCMCredential UnsupportedAuthentication)
		(AuthenticationOk AuthenticationOk)
		(ConnectionFailed ConnectionFailed)
		(Terminate Terminated)
		(ErrorResponse TerminalError)))
	(SendingCleartextPassword (
		(AuthenticationOk AuthenticationOk)
		(Terminate Terminated)
		(ErrorResponse TerminalError)))
	(SendingMD5Password (
		(AuthenticationOk AuthenticationOk)
		(Terminate Terminated)
		(ErrorResponse TerminalError)))
	(UnsupportedAuthentication (
		(Terminate Terminated)))
	(AuthenticationOk (
		(BackendKeyData GotBackendKeyData)
		(Terminate Terminated)
		(ErrorResponse TerminalError)))
	(GotBackendKeyData (
		(ReadyForQuery ReadyForQuery)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(ReadyForQuery (
		(Query Querying)
		(FunctionCall FunctionCall)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(Querying (
		(CursorResponse GotCursor)
		(CopyOutResponse GotCopyOut)
		(CopyInResponse GotCopyIn)
		(CompletedResponse GotCompleted)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(FunctionCall (
		(FunctionResultResponse GotFunctionResult)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(GotCursor (
		(RowDescription GotRowDescription)
		(CompletedResponse GotCompleted)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(GotRowDescription (
		(AsciiRow GotRow)
		(BinaryRow GotRow)
		(CompletedResponse GotCompleted)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(GotRow (
		(AsciiRow GotRow)
		(BinaryRow GotRow)
		(CompletedResponse GotCompleted)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(GotCopyOut (
		(CompletedResponse GotCompleted)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(GotCopyIn (
		(CompletedResponse GotCompleted)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(GotFunctionResult (
		(ReadyForQuery ReadyForQuery)
		(CompletedResponse GotCompleted)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(GotCompleted (
		(ReadyForQuery ReadyForQuery)
		(CursorResponse GotCursor)
		(CompletedResponse GotCompleted)
		(Terminate Terminated)
		(ErrorResponse ErrorResponse)))
	(Terminated (
		(Startup Startup)))
	(ConnectionFailed (
		(Startup Startup)
		(Query EventIgnored)
		(FunctionCall EventIgnored)
		(Terminate EventIgnored)))
	(ErrorResponse (
		(Terminate Terminated)
		(ReadyForQuery ReadyForQuery)
		(CompletedResponse GotCompleted)))
	(TerminalError (
		))
	)
	inject: IdentityDictionary new
	into: [:table :each |
		table
			at: (each at: 1)
			put: ((each at: 2)
					inject: IdentityDictionary new
					into: [:stateTransitions :transition |
						stateTransitions at: (transition at: 1) put: (transition at: 2).
						stateTransitions]).
		table].
! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 02:39'!
characterConverter

	^[ :s | s ]! !

!PGConnection class methodsFor: 'converters' stamp: 'ul 9/13/2009 15:58'!
dateConverter 

	^[:s |
		Date
			year: (s copyFrom: 1 to: 4) asInteger
			month: (s copyFrom: 6 to: 7) asInteger
			day: (s copyFrom: 9 to: 10) asInteger ]
! !

!PGConnection class methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
defaultConnectionArgs
	DefaultConnectionArgs isNil ifTrue: [DefaultConnectionArgs := self buildDefaultConnectionArgs].
	^ DefaultConnectionArgs
! !

!PGConnection class methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
defaultConnectionArgs: aConnectionArgs
	"self defaultConnectionArgs: nil"

	DefaultConnectionArgs := aConnectionArgs
! !

!PGConnection class methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
defaultTraceLevel
	DefaultTraceLevel isNil ifTrue: [DefaultTraceLevel := 0].
	^DefaultTraceLevel! !

!PGConnection class methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
defaultTraceLevel: anInteger
	"
	PGConnection defaultTraceLevel: 0.
	PGConnection defaultTraceLevel: 2.
	PGConnection defaultTraceLevel: 5.
	PGConnection defaultTraceLevel: 8.
	PGConnection defaultTraceLevel: 10.
	"

	DefaultTraceLevel := anInteger! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 04:09'!
floatConverter

	^[ :s | (Number readFrom: (ReadStream on: s)) asFloat ]! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 02:48'!
integerArrayConveter

	^[:s | 
		| readStream |
		readStream := s readStream.
		readStream next.
		Array streamContents: [ :stream | 
			[ readStream atEnd or: [ readStream peek = $} ] ] whileFalse: [ 
				stream nextPut: (self readIntegerFrom: readStream).
				readStream next ] ] ]
! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 02:42'!
integerConveter

	^[ :s | self readIntegerFrom: (ReadStream on: s) ].
! !

!PGConnection class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
new

	^self basicNew initialize
! !

!PGConnection class methodsFor: 'private' stamp: 'kb 1/31/2009 03:06'!
nextBooleanFrom: readStream

	| firstChar result |
	firstChar := readStream next.
	result := firstChar caseOf: { 
		[ $t ] -> [ true ].
		[ $T ] -> [ true ].
		[ $f ] -> [ false ].
		[ $F ] -> [ false ].
		[ $N ] -> [ 
			(readStream next: 3) = 'ULL' ifFalse: [
				self parseError ].
			nil ] }.
	readStream skip: 1.
	^result! !

!PGConnection class methodsFor: 'private' stamp: 'EstebanMaringolo 5/18/2014 22:27'!
nextDateAndTimeFrom: string
	"Accepted format: 'YYYY-MM-DD HH:MM:SS[.ss...s][(+|-)HH]' fractional seconds and timezone are optional"
	"#( '1967-08-07 18:50:12+02' '1967-08-07 18:50:12' '1967-08-07 18:50:12.12+02' 
		'1967-08-07 18:50:12.123+02' '1967-08-07 18:50:12.123456' ) 
		collect: [ :each | self nextDateAndTimeFrom: each ] "
	
	| stream parser parseInteger direction fractionalSeconds offset |
	stream := ReadStream on: string.
	parser := NumberParser on: stream.
	parseInteger := [ :from :to | 
		stream setFrom: from to: to. 
		parser nextUnsignedIntegerBase: 10 ].
	fractionalSeconds := 0.
	offset := DateAndTime localOffset.
	string size > 19 
		ifTrue: [ | offsetStart |
			(string at: 20) = $.
				ifTrue: [
					offsetStart := 21.
					[ offsetStart <= string size and: [ (string at: offsetStart) isDigit ] ]
						whileTrue: [ offsetStart := offsetStart + 1 ].
					offsetStart > 21 ifTrue: [ fractionalSeconds := parseInteger value: 21 value: offsetStart - 1 ] ]
				ifFalse: [ 
					offsetStart := 20 ].
			offsetStart <= string size
				ifTrue: [	
					direction := (string at: offsetStart) = $- ifTrue: [ -1 ] ifFalse: [ 1 ].
					offset := Duration hours: (parseInteger value: offsetStart + 1 value: string size) * direction ] ].
	^ DateAndTime
		year: (parseInteger value: 1 value: 4)
		month: (parseInteger value: 6 value: 7)
		day: (parseInteger value: 9 value: 10)
		hour: (parseInteger value: 12 value: 13)
		minute: (parseInteger value: 15 value: 16)
		second: (parseInteger value: 18 value: 19)
		nanoSecond: fractionalSeconds * (10 raisedToInteger: (9 - fractionalSeconds numberOfDigits))
		offset: offset! !

!PGConnection class methodsFor: 'private' stamp: 'kb 10/2/2008 16:37'!
nextStringFrom: readStream

	| escape |
	^String streamContents: [ :stream |
		readStream peek = $" 
			ifFalse: [ 
				[ #($, $}) includes: readStream peek ] whileFalse: [ 
					stream nextPut: readStream next ] ]
			ifTrue: [
				escape := false.
				readStream skip: 1.
				[ escape not and: [ readStream peek = $" ] ] whileFalse: [ 
					| character |
					character := readStream next.
					escape 
						ifTrue: [
							stream nextPut: character.
							escape := false ]
						ifFalse: [
							escape := character = $\.
							escape ifFalse: [ stream nextPut: character ] ].
					].
				readStream skip: 1 ].
		readStream skip: 1 " drop comma or curlybrace " ]! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 04:13'!
numericConverter
	"This should convert the value to ScaledDecimal"

	^[ :s | (Number readFrom: (ReadStream on: s)) asFloat ]! !

!PGConnection class methodsFor: 'private' stamp: 'kb 1/31/2009 03:04'!
readIntegerFrom: readStream

	| next result sign |
	readStream atEnd ifTrue: [ ^self parseError ].
	readStream peek caseOf: {
		[ $- ] -> [
			sign := -1.
			readStream skip: 1 ].
		[ $N ] -> [
			(readStream next: 4) = 'NULL' ifTrue: [ ^nil].
			self parseError ]}
		otherwise: [ sign := 1 ].
	result := 0.
	[ (next := readStream next) == nil or: [
		(next := next asciiValue - 48) < 0 or: [
			next > 9 ] ] ] whileFalse: [
		result := result * 10 + next ].
	readStream skip: -1.
	^result * sign
! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 03:21'!
stringArrayConveter

	^[ :s |
		| readStream |
		readStream := s readStream.
		readStream next.
		Array streamContents: [ :stream | 
			[ readStream atEnd or: [ readStream peek = $} ] ] whileFalse: [
				stream nextPut: (self nextStringFrom: readStream) ] ] ]! !

!PGConnection class methodsFor: 'tests' stamp: 'kb 1/31/2009 04:36'!
testConvertersWith: aPGConnection

	{ 
		'select b::boolean from (values (true), (false), (null)) t(b)' -> #(true false nil).
		'select array[true, false, null]::boolean[]' -> #((true false nil)).
		'select i::integer from (values (-1), (1), (null), (1234567890)) t(i)' -> #(-1 1 nil 1234567890).
		'select array[1, 2, null, -1]::integer[]' -> #((1 2 nil -1)).
		"'select array[''foo'', ''bar'', null, ''baz'']::text[]' -> #(('foo' 'bar' nil 'baz'))"
		'select d::date from (values (''1234-12-30''), (null), (''2009-01-31'')) t(d)' -> { Date year: 1234 month: 12 day: 30. nil. Date year: 2009 month: 1 day: 31 }.
		
	} do: [ :each |
		| dataRows |
		dataRows := (aPGConnection executeAndCheckResult: each key) dataRows.
		self assert: (dataRows collect: [ :row | row at: 1 ]) asArray = each value ]
	! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 04:15'!
timeConverter 

	^[ :s | Time readFrom: (ReadStream on: s) ]! !

!PGConnection class methodsFor: 'converters' stamp: 'kb 1/31/2009 04:19'!
timeWithTimezoneConverter
 
	^[:s |
		| list |
		list := (s subStrings: ':') collect:[:i | i asInteger].
		Time fromSeconds: ((list at: 1) * 3600) + ((list at: 2) * 60) + (list at: 3) ]

! !

!PGConnection class methodsFor: 'converters' stamp: 'SvenVanCaekenberghe 10/31/2011 13:34'!
timestampConverter 

	^[:s | self nextDateAndTimeFrom: s]! !

!PGConnection class methodsFor: 'converters' stamp: 'SvenVanCaekenberghe 10/31/2011 13:33'!
timestampWithTimezoneConverter

	^[ :s | self nextDateAndTimeFrom: s]! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
addNotificationSubscriber: aNotificationSubscriber

	^ self notificationSubscribers add: aNotificationSubscriber
! !

!PGConnection methodsFor: 'api' stamp: 'yj 4/24/2003 23:01'!
cancelRequest
	"Issue a cancel request. Open a new connection to the server and send a CancelRequest message."

	self sendCancel.
! !

!PGConnection methodsFor: 'as yet unclassified' stamp: 'kb 11/28/2008 11:11'!
clientEncoding: aSymbol

	sqlStringConverter := [ :sqlString | 
		sqlString convertToEncoding: aSymbol ].
	receivingTextConverter := TextConverter newForEncoding: aSymbol.
	#(25 1043) do: [ 	:each | 
		self fieldConverters  at: each put: [ :s | 
			s convertFromWithConverter: receivingTextConverter ] ].	
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
closeSocket

	self closeSocket: socket
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
closeSocket: aSocket

	trace >= 2
		ifTrue: [ self log: 'closeSocket' text: 'hostname: ', connectionArgs hostname, ':', connectionArgs portno printString ].
	trace >= 2
		ifTrue: [ self log: 'closeSocket' text: 'socket: ', aSocket printString ].

	aSocket closeAndDestroy.

	trace >= 2
		ifTrue: [ self log: 'closeSocket' text: 'socket: ', aSocket printString ].
! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
connectionArgs
	^connectionArgs! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
connectionArgs: aConnectionArgs
	connectionArgs := aConnectionArgs! !

!PGConnection methodsFor: 'api' stamp: 'yj 4/24/2003 23:01'!
copy: copySql withStream: aStream

	"The syntax of a COPY command is:

	COPY [ BINARY ] table [ WITH OIDS ]
		FROM { 'filename' | stdin }
		[ [USING] DELIMITERS 'delimiter' ]
		[ WITH NULL AS 'null string' ]

	COPY [ BINARY ] table [ WITH OIDS ]
		TO { 'filename' | stdout }
		[ [USING] DELIMITERS 'delimiter' ]
		[ WITH NULL AS 'null string' ]

	The 'stdin' or 'stdout' option must be used, not the 'filename' option.
	'aStream' will supply the COPY...FROM input.
	'aStream' will received the COPY...TO output.
	"

	sql := copySql.
	copyStream := aStream.
	self queueEvent: #Query.
	self saProcessEventsUntil: #(ReadyForQuery ConnectionFailed).
	^ result
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
copyInDataRows
	"copyStream is initially positioned at the start of a data rows stream.
	The contents are sent down the socket.

	In a stream of data rows, each row is terminatated by a Byte1('\n').
	A sequence of Byte1('\\'), Byte1('.'), Byte1('\n') is the last line.
	"

	trace >= 8
		ifTrue: [ self log: 'copyInDataRows' text: copyStream contents printString ].

	socket sendData: copyStream contents.
	"socket sendData: (String with: $\ with: $. with: Character lf)."
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
copyOutDataRows

	| ch lf notDone pch ppch |
	lf := Character lf.
	notDone := true.
	pch := $x.
	ch := $x.
	[notDone] whileTrue: [
		ppch := pch.
		pch := ch.
		ch := self next.
		copyStream nextPut: ch.
		((ch = lf and: [pch = $.]) and: [ppch = $\])
			ifTrue: [notDone := false].
	].

! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
copyStream
	^copyStream! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
copyStream: aStream
	copyStream := aStream! !

!PGConnection methodsFor: 'api' stamp: 'kb 2/14/2009 20:32'!
execute: sqlString

	trace >= 2 ifTrue: [self log: 'execute' text: sqlString].

	self isConnected ifFalse: [ self error: 'Connection not valid' ].

	sql := sqlString convertToWithConverter: receivingTextConverter. "sqlStringConverter value: sqlString."
	self queueEvent: #Query.
	self saProcessEventsUntil: #(ReadyForQuery ConnectionFailed).

	"There's an extra result set, so nuke it here."
	result resultSets size > 0
		ifTrue: [ result resultSets removeLast ].

	^ result
! !

!PGConnection methodsFor: 'api' stamp: 'pf 11/28/2007 11:52'!
execute: sqlString withRowBlock: aRowBlock
	"Iterate thru resultset with block (for each row) without loading all bulk resultset data into memory (internal arrays). Implemented by database CURSORs.
	Row block has 2 parameters: 
		1) row description (PGRowDescription - column names, data types etc.)
		2) row data (OrderedCollection)"
	| cursorName rslt rowDesc rows |
	cursorName := 'squeakTempCursor', Time now nanoSecond asString.
	self executeAndCheckResult: 'BEGIN WORK'.
	[ 	self executeAndCheckResult: 'DECLARE ', cursorName, ' CURSOR FOR ', sqlString asString.
		[ 
			[	rslt := self executeAndCheckResult: 'FETCH FORWARD 5000 FROM ', cursorName.
				rowDesc := rslt resultSets first rowDescription.
				rows := rslt resultSets first rows.
				rows size > 0.
			] whileTrue: [
				rows do: [ :row | aRowBlock value: rowDesc value: row data ].				
				].						
		] ensure: [ self executeAndCheckResult: 'CLOSE ', cursorName ]
	] ensure: [ self executeAndCheckResult: 'COMMIT WORK' ].
	
! !

!PGConnection methodsFor: 'api' stamp: 'pf 11/28/2007 11:52'!
executeAndCheckResult: sqlString
	"Same as execute: but check responce - throw exception if error in responce" 
	| res |
	res := self execute: sqlString.
	(res errorResponse isKindOf: PGErrorResponse) ifTrue: [ Error signal: res errorResponse value ].
	^ res.
! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
fieldConverterAt: typeOid
	^ fieldConverters at: typeOid ifAbsent: [nil]
! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
fieldConverterAt: typeOid put: converter
	fieldConverters at: typeOid put: converter
! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
fieldConverters
	^ fieldConverters! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
fieldConverters: anObject
	fieldConverters := anObject! !

!PGConnection methodsFor: 'api' stamp: 'yj 4/24/2003 23:01'!
functionCall: oid arguments: arguments

	functionCallOid := oid.
	functionCallArgs := arguments.
	self queueEvent: #FunctionCall.
	self saProcessEventsUntil: #(ReadyForQuery ConnectionFailed).
	^ result
! !

!PGConnection methodsFor: 'initialize/release' stamp: 'noha 11/26/2007 16:23'!
initialize

	| readBufferSize |

	super initialize.

	trace := self class defaultTraceLevel.
	readBufferSize := 8096.
	readBuffer := String new: readBufferSize.
	readIndex := readBufferSize + 1.
	lastReadIndex := readBufferSize.

	self fieldConverters: self class buildDefaultFieldConverters.
	result := PGResult on: self.

	sqlStringConverter := [:sqlString| sqlString].
	"^ self"
! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
isConnected
	^ socket notNil and: [ socket isConnected]! !

!PGConnection methodsFor: 'private-actions' stamp: 'kb 2/14/2009 20:26'!
next
	readIndex >= lastReadIndex 
		ifTrue: 
			[trace >= 10 
				ifTrue: [self log: 'next' text: '**** filling read buffer ****'].
			"(Delay forMilliseconds: 500) wait."
			socket waitForData. "For: Socket standardTimeout."
			
			[(lastReadIndex := socket receiveDataInto: readBuffer) = 0 
				ifTrue: 
					[trace >= 10 
						ifTrue: [self log: 'next' text: '**** zero length received from socket ****'].
					(Delay forMilliseconds: 100) wait].
			lastReadIndex = 0] 
					whileTrue.
			readIndex := 0.
			trace >= 10 
				ifTrue: 
					[self log: 'next' text: '**** read ' , lastReadIndex printString , ' ****']].
	readIndex := readIndex + 1.
	trace >= 10 
		ifTrue: 
			[self log: 'next'
				text: 'readIndex=' , readIndex printString , ',lastReadIndex=' 
						, lastReadIndex printString , ',ch=' 
						, (readBuffer at: readIndex) printString].
	^readBuffer at: readIndex! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
nextEvent

	| pkt noticeFlag |

	[
		pkt := self receivePacket.
		(noticeFlag := #(NoticeResponse NotificationResponse) includes: pkt eventName)
			ifTrue: [ self notifySubscribers: pkt ].
		noticeFlag.
	] whileTrue.
	^ pkt
! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
notificationSubscribers

	notificationSubscribers isNil ifTrue: [ notificationSubscribers := OrderedCollection new ].
	^ notificationSubscribers
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
notifySubscribers: pkt

	notificationSubscribers isNil
		ifTrue: [ self logInfo: 'NOTIFICATION: ', pkt printString ]
		ifFalse: [ notificationSubscribers do: [:each | each receive: pkt from: self ]].
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 10/16/2003 10:58'!
openSocket
	| newSocket |
	trace >= 2 
		ifTrue: 
			[self log: 'openSocket'
				text: 'hostname: ' , connectionArgs hostname , ':' 
						, connectionArgs portno printString].
	Socket initializeNetwork.
	newSocket := Socket newTCP.
	newSocket 
		connectTo: (NetNameResolver addressForName: connectionArgs hostname
				timeout: 15)
		port: connectionArgs portno.
	newSocket waitForConnectionFor: Socket standardTimeout ifTimedOut: [newSocket := nil].
	trace >= 2 
		ifTrue: [self log: 'openSocket' text: 'socket: ' , newSocket printString].
	^newSocket! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 11/12/2004 18:27'!
receivePacket

	| typeCode packet |

	typeCode := self next.
	trace >= 5
		ifTrue: [ self log: 'packet typeCode=' text: typeCode printString ].

	packet := PGPacket newPacket: typeCode.

	packet == nil
		ifTrue: [packet := #UnknownPacket]
		ifFalse: [packet receiveFrom: self ].

	trace >= 5
		ifTrue: [ self log: 'receivePacket' text: packet printString ].

	^ packet
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
resetResult
	"Clear the result, a new query or function call will follow."

	result
		reset;
		addResultSet.
! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
result
	^result! !

!PGConnection methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
result: aResult
	result := aResult! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
sendCancel

	| cancelRequestSocket |

	trace >= 2
		ifTrue: [ self log: 'sendCancel' text: 'processId=', processId printString ].

	cancelRequestSocket := self openSocket.
	self sendPacket: (PGCancelRequest processId: processId secretKey: secretKey) on: cancelRequestSocket.
	self closeSocket: cancelRequestSocket.
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
sendPacket: aPacket on: aSocket

	| s |
	s := WriteStream on: String new.
	aPacket writeOn: s.

	trace >= 5
		ifTrue: [
			self log: 'sendPacket' text: aPacket printString.
			trace >= 10 ifTrue: [self log: 'sendPacket' text: s contents printString].
		].

	aSocket sendData: s contents.
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
sendStartup

	self sendPacket: (PGStartupPacket databaseName: connectionArgs databaseName userName: connectionArgs userName) on: socket.
! !

!PGConnection methodsFor: 'private-actions' stamp: 'yj 4/24/2003 23:01'!
sendTerminate

	self sendPacket: PGTerminate new on: socket.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stAuthenticationOk: event

	"Do nothing"
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stCantHappen: event
	"Try to send the terminate packet, then close the socket"

	self isConnected ifTrue: [ self sendTerminate ].
	socket isNil ifFalse: [ self closeSocket ].
	super stCantHappen: event.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stConnectionFailed: event

	"Do nothing"
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stErrorResponse: event

	result errorResponse: event.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stFunctionCall: event

	self resetResult.
	self sendPacket: (PGFunctionCall oid: functionCallOid arguments: functionCallArgs) on: socket.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stGotBackendKeyData: backendKeyData
	"event is a BackendKeyData packet."

	processId := backendKeyData processId.
	secretKey := backendKeyData secretKey.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stGotCompleted: event

	result completedResponse: event.

	"This causes an extra result set to be added.
	But a result set has to be available at this point,
	given the current state machine.
	"
	result addResultSet.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stGotCopyIn: event

	self copyInDataRows.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stGotCopyOut: event

	self copyOutDataRows.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stGotCursor: event

	"Do nothing"
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stGotFunctionResult: event

	result functionResult: event.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stGotRow: event

	result rows add: event.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stGotRowDescription: event

	result rowDescription: event.
! !

!PGConnection methodsFor: 'private-states' stamp: 'TudorGirba 3/2/2014 17:42'!
stQuerying: event
	self resetResult.
	self sendPacket: (PGQuery sql: sql) on: socket.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stReadyForQuery: event

	"Do nothing"
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stSendingCleartextPassword: event

	self sendPacket: (PGPasswordPacket password: connectionArgs password) on: socket.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 1/31/2006 18:57'!
stSendingMD5Password: event 
	"MD5 authentication as explain in http://archives.postgresql.org/pgsql-novice/2003-05/msg00305.php"
	| hashedCredentials hashedMessage |

	hashedCredentials := (MD5 hashMessage: (connectionArgs password, connectionArgs userName)) hex asLowercase.
	hashedMessage := 'md5', (MD5 hashMessage: (hashedCredentials, event salt asString)) hex asLowercase.

	self	sendPacket: (PGPasswordPacket password: hashedMessage) on: socket.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stStartup: event

	self resetResult.
	socket := self openSocket.
	socket isNil
		ifTrue: [ self generateEvent: #ConnectionFailed to: self ]
		ifFalse: [ self sendStartup ].
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stTerminalError: event

	result errorResponse: event.
	self closeSocket: socket.
	socket := nil.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 4/24/2003 23:01'!
stTerminated: event

	self sendTerminate.
	self closeSocket: socket.
	socket := nil.
! !

!PGConnection methodsFor: 'private-states' stamp: 'yj 1/31/2006 22:52'!
stUnsupportedAuthentication: event

	"result errorResponse: 'Unsupported authentication method: ', event eventName."

	PGUnsupportedAuthentication signal: 'Unsupported authentication method: ', event eventName.
! !

!PGConnection methodsFor: 'api' stamp: 'noha 12/7/2007 15:12'!
startup

	self connectionArgs isNil ifTrue: [
		self connectionArgs: self class defaultConnectionArgs.
	].
	self connectionArgs clientEncoding ifNotNil: [
		self clientEncoding: self connectionArgs clientEncoding.
	] ifNil: [
		self clientEncoding: #utf8
	].
	self queueEvent: #Startup.
	self saProcessEventsUntil: #(ReadyForQuery ConnectionFailed TerminalError UnsupportedAuthentication).
	^ result
! !

!PGConnection methodsFor: 'api' stamp: 'yj 4/24/2003 23:01'!
terminate

	self queueEvent: #Terminate.
	self saProcessEventsUntil: #(Terminated ConnectionFailed).
! !

PGActiveObject subclass: #PGNotificationSubscriber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGNotificationSubscriber methodsFor: 'api' stamp: 'yj 4/24/2003 23:01'!
receive: notice from: aConnection

	self logInfo: notice printString, ' received from ', aConnection logIdString.
! !

Object subclass: #PGConnectionArgs
	instanceVariableNames: 'hostname portno databaseName userName password extraArgs debugTty clientEncoding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGConnectionArgs class methodsFor: 'instance creation' stamp: 'yj 11/28/2005 17:30'!
hostname: host portno: port databaseName: database userName: user password: pwd
	^(self new)
		hostname: host;
		portno: port;
		databaseName: database;
		userName: user;
		password: pwd;
		yourself! !

!PGConnectionArgs class methodsFor: 'instance creation' stamp: 'yj 11/28/2005 17:30'!
hostname: host portno: port databaseName: database userName: user password: pwd extraArgs: extra debugTty: debug
	^(self new)
		hostname: host;
		portno: port;
		databaseName: database;
		userName: user;
		password: pwd;
		extraArgs: extra;
		debugTty: debug;
		yourself! !

!PGConnectionArgs methodsFor: 'as yet unclassified' stamp: 'noha 11/26/2007 16:08'!
clientEncoding
	^ clientEncoding! !

!PGConnectionArgs methodsFor: 'as yet unclassified' stamp: 'noha 11/26/2007 16:08'!
clientEncoding: aSymbol
	clientEncoding := aSymbol! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
databaseName
	^databaseName! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 11/28/2005 17:28'!
databaseName: anObject
	databaseName := anObject! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
debugTty
	^debugTty! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 11/28/2005 17:28'!
debugTty: anObject
	debugTty := anObject! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
extraArgs
	^extraArgs! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 11/28/2005 17:28'!
extraArgs: anObject
	extraArgs := anObject! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
hostname
	^hostname! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 11/28/2005 17:28'!
hostname: anObject
	hostname := anObject! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
password
	^password! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 11/28/2005 17:28'!
password: anObject
	password := anObject! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
portno
	^portno! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 11/28/2005 17:28'!
portno: anObject
	portno := anObject! !

!PGConnectionArgs methodsFor: 'private-initialize' stamp: 'yj 4/24/2003 23:01'!
setHostname: host portno: port databaseName: database userName: user password: pwd extraArgs: extra debugTty: debug

	hostname := host.
	portno := port.
	databaseName := database.
	userName := user.
	password := pwd.
	extraArgs := extra.
	debugTty := debug.
	^self! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
userName
	^userName! !

!PGConnectionArgs methodsFor: 'accessing' stamp: 'yj 11/28/2005 17:28'!
userName: anObject
	userName := anObject! !

Object variableSubclass: #PGDataRow
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGDataRow class methodsFor: 'as yet unclassified' stamp: 'kb 10/30/2008 16:42'!
for: aDictionary

	^(self new: aDictionary size)
		dictionary: aDictionary;
		yourself! !

!PGDataRow methodsFor: 'as yet unclassified' stamp: 'kb 10/30/2008 17:03'!
atName: aSymbol

	^self at: (dictionary at: aSymbol)! !

!PGDataRow methodsFor: 'as yet unclassified' stamp: 'kb 10/30/2008 17:11'!
atName: aSymbol ifAbsent: aBlock

	^self at: (dictionary 
		at: aSymbol
		ifAbsent: [ ^aBlock value ])! !

!PGDataRow methodsFor: 'accessing' stamp: 'kb 3/12/2009 17:32'!
dictionary
	
	^dictionary! !

!PGDataRow methodsFor: 'as yet unclassified' stamp: 'kb 10/30/2008 16:39'!
dictionary: anIdentityDictionary

	dictionary := anIdentityDictionary ! !

!PGDataRow methodsFor: 'as yet unclassified' stamp: 'kb 10/30/2008 16:54'!
doesNotUnderstand: aMessage

	^self at: (
		dictionary 
			at: aMessage selector
			ifAbsent: [ ^super doesNotUnderstand: aMessage ])! !

!PGDataRow methodsFor: 'as yet unclassified' stamp: 'kb 11/28/2008 12:22'!
indexOf: aSymbol

	^dictionary at: aSymbol ifAbsent: 0! !

!PGDataRow methodsFor: 'as yet unclassified' stamp: 'kb 10/30/2008 17:03'!
name

	^self atName: #name! !

!PGDataRow methodsFor: 'as yet unclassified' stamp: 'kb 11/8/2008 12:55'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	(dictionary associations
		sort: [ :a :b | a value < b value ])
		do: [ :assoc |
			aStream 
				nextPutAll: assoc key;
				nextPutAll: ': ';
				print: (self at: assoc value) ]
		separatedBy: [ aStream nextPutAll: ', ' ].
	aStream nextPut: $)! !

Object subclass: #PGPacket
	instanceVariableNames: ''
	classVariableNames: 'PacketClasses'
	poolDictionaries: ''
	category: 'PostgresV2'!

PGPacket subclass: #PGAbstractStringResponse
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGAbstractStringResponse methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'value='; nextPutAll: value printString;
		nextPutAll: ')'
! !

!PGAbstractStringResponse methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
receiveFrom: aStream

	value := self readStringFrom: aStream.
! !

!PGAbstractStringResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
value
	^value! !

PGAbstractStringResponse subclass: #PGCompletedResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGCompletedResponse methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
displayOn: aStream

	aStream nextPutAll: value.
! !

!PGCompletedResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#CompletedResponse! !

PGAbstractStringResponse subclass: #PGCursorResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGCursorResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#CursorResponse! !

PGAbstractStringResponse subclass: #PGEmptyQueryResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGEmptyQueryResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#EmptyQueryResponse! !

PGAbstractStringResponse subclass: #PGErrorResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGErrorResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#ErrorResponse! !

PGAbstractStringResponse subclass: #PGNoticeResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGNoticeResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#NoticeResponse! !

PGPacket subclass: #PGAsciiRow
	instanceVariableNames: 'description nullFields rawData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGAsciiRow class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
description: aRowDescription

	^self new
		description: aRowDescription;
		yourself.
! !

!PGAsciiRow class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
new

	^self basicNew initialize.
! !

!PGAsciiRow methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
data

	| converters converter data |

	converters := description resultSet result connection fieldConverters.
	data := OrderedCollection new.
	rawData with: description columnDescriptions do: [:each :aColumnDescription |
		data addLast: (
			each isNil
				ifTrue: [nil]
				ifFalse: [
					converter := converters at: aColumnDescription typeOid ifAbsent: [nil].
					converter isNil ifTrue: [ each ] ifFalse: [ converter value: each ].
				]).
	].
	^data
! !

!PGAsciiRow methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
dataKeyedByFieldName

	| d |

	d := Dictionary new.
	self data with: description columnDescriptions do: [:each :aColumnDescription |
		d at: aColumnDescription fieldName put: each.
	].
	^ d
! !

!PGAsciiRow methodsFor: 'accessing' stamp: 'kb 10/30/2008 16:46'!
dataRow

	| converters converter data dictionary index |

	converters := description resultSet result connection fieldConverters.
	dictionary := description columnDescriptionDictionary.
	data := PGDataRow for: dictionary.
	index := 0.
	rawData with: description columnDescriptions do: [ :each :aColumnDescription |
		data
			at: (index := index + 1)
			put: (
				each ifNotNil: [
					(converter := converters at: aColumnDescription typeOid ifAbsent: nil)
						ifNil: [ each ]
						ifNotNil: [ converter reentrant value: each ] ]) ].
	^data
! !

!PGAsciiRow methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
description: aRowDescription
	description := aRowDescription.
! !

!PGAsciiRow methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
displayOn: aStream

	rawData withIndexDo: [:each :i |
		aStream nextPutAll: (each == nil ifTrue: ['0'] ifFalse: [each]).
		i < rawData size ifTrue: [aStream space].
	].
! !

!PGAsciiRow methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#AsciiRow! !

!PGAsciiRow methodsFor: 'initialize' stamp: 'yj 4/24/2003 23:01'!
initialize

	rawData := OrderedCollection new.
	^self! !

!PGAsciiRow methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '('.
	rawData do: [:each | each printOn: aStream. aStream nextPut: $,].
	aStream nextPutAll: ')'.
! !

!PGAsciiRow methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
rawData
	^ rawData! !

!PGAsciiRow methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
receiveFrom: connection

	| ncol |

	description := connection result rowDescription.
	ncol := description numberOfColumns.
	nullFields := self readBitmap: ncol from: connection.
	0 to: ncol - 1 do: [:i |
		((nullFields at: (i // 8) + 1) bitAnd: (2r10000000 bitShift: (i \\ 8) negated)) > 0
			ifTrue: [rawData add: (self readFieldFrom: connection)]
			ifFalse: [rawData add: nil].
	].
! !

PGAsciiRow subclass: #PGBinaryRow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGBinaryRow methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#BinaryRow! !

PGPacket subclass: #PGAuthentication
	instanceVariableNames: 'type salt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGAuthentication methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName

	type > 6 ifTrue: [self error: 'Unknown authentication type'].

	^#(
		AuthenticationOk
		AuthenticationKerberosV4
		AuthenticationKerberosV5
		AuthenticationCleartextPassword
		AuthenticationCryptPassword
		AuthenticationMD5Password
		AuthenticationSCMCredential
	) at: (type + 1)
! !

!PGAuthentication methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'type='; nextPutAll: type printString;
		nextPutAll: ',salt='; nextPutAll: salt printString;
		nextPutAll: ')'
! !

!PGAuthentication methodsFor: 'receiving' stamp: 'yj 1/31/2006 22:27'!
receiveFrom: connection

	type := self readInt32From: connection.

	"AuthenticationCryptPassword"
	type == 4 ifTrue: [ salt := self readByteN: 2 from: connection ].

	"AuthenticationMD5Password"
	type == 5 ifTrue: [ salt := self readByteN: 4 from: connection ].

	"
	For documentation purposes here are the other authentication methods.
	There is no other packet data to read in these cases.

	type == 1 AuthenticationKerberosV4
	type == 2 AuthenticationKerberosV5
	type == 3 AuthenticationCleartextPassword
	type == 6 AuthenticationSCMCredential
	"
! !

!PGAuthentication methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
salt
	^salt! !

!PGAuthentication methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
salt: anInteger
	salt := anInteger! !

!PGAuthentication methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
type
	^type! !

!PGAuthentication methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
type: anInteger
	type := anInteger! !

PGPacket subclass: #PGBackendKeyData
	instanceVariableNames: 'processId secretKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGBackendKeyData methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#BackendKeyData! !

!PGBackendKeyData methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'processId='; nextPutAll: processId printString;
		nextPutAll: ',secretKey='; nextPutAll: secretKey printString;
		nextPutAll: ')'
! !

!PGBackendKeyData methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
processId
	^processId! !

!PGBackendKeyData methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
processId: anInteger
	processId := anInteger! !

!PGBackendKeyData methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
receiveFrom: aStream

	processId := self readInt32From: aStream.
	secretKey := self readInt32From: aStream.
! !

!PGBackendKeyData methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
secretKey
	^secretKey! !

!PGBackendKeyData methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
secretKey: anInteger
	secretKey := anInteger! !

PGPacket subclass: #PGCancelRequest
	instanceVariableNames: 'processId secretKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGCancelRequest class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
processId: pid secretKey: secretKey

	^self new
		processId: pid;
		secretKey: secretKey;
		yourself.
! !

!PGCancelRequest methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#CancelRequest! !

!PGCancelRequest methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
processId
	^processId! !

!PGCancelRequest methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
processId: anInteger
	processId := anInteger! !

!PGCancelRequest methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
secretKey
	^secretKey! !

!PGCancelRequest methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
secretKey: anInteger
	secretKey := anInteger! !

!PGCancelRequest methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeOn: aStream
	"Write a cancel request on the stream."

	"80877102 - The cancel request code.
	The value is chosen to contain 1234 in the most significant 16 bits,
	and 5678 in the least 16 significant bits. (To avoid confusion,
	this code must not be the same as any protocol version number.)
	"

	self writeInt32: 16 on: aStream.
	self writeInt32: 80877102 on: aStream. "major=1234, minor=5678"
	self writeInt32: self processId on: aStream.
	self writeInt32: self secretKey on: aStream.
! !

PGPacket subclass: #PGColumnDescription
	instanceVariableNames: 'fieldName typeOid typeSize typeModifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGColumnDescription methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
displayOn: aStream

	aStream nextPutAll: fieldName.
! !

!PGColumnDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#ColumnDescription! !

!PGColumnDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
fieldName
	^ fieldName! !

!PGColumnDescription methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'fieldName='; nextPutAll: fieldName printString;
		nextPutAll: ',typeOid='; nextPutAll: typeOid printString;
		nextPutAll: ',typeSize='; nextPutAll: typeSize printString;
		nextPutAll: ',typeModifier='; nextPutAll: typeModifier printString;
		nextPutAll: ')'
! !

!PGColumnDescription methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
receiveFrom: connection

	fieldName := self readStringFrom: connection.
	typeOid := self readInt32From: connection.
	typeSize := self readInt16From: connection.
	typeModifier := self readInt32From: connection.
! !

!PGColumnDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
typeModifier
	^ typeModifier! !

!PGColumnDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
typeOid
	^ typeOid! !

!PGColumnDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
typeSize
	^ typeSize! !

PGPacket subclass: #PGCopyInResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGCopyInResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#CopyInResponse! !

PGPacket subclass: #PGCopyOutResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGCopyOutResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#CopyOutResponse! !

PGPacket subclass: #PGFunctionCall
	instanceVariableNames: 'oid arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGFunctionCall class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
oid: anInteger arguments: aCollection
	"Return a new instance of the receiver.

	'anInteger' specifies the object ID of the function to call. The object ID is a site specific PostgreSQL value.
	'aCollection' contains the arguments of the function call. It should contain String values, which may have non-printable characters (i.e. values 0..255).
	"

	^ self new setOid: anInteger arguments: aCollection
! !

!PGFunctionCall methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
arguments
	^arguments! !

!PGFunctionCall methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
arguments: value
	arguments := value! !

!PGFunctionCall methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
oid
	^oid! !

!PGFunctionCall methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
oid: value
	oid := value! !

!PGFunctionCall methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'oid='; nextPutAll: oid printString;
		nextPutAll: ',arguments='; nextPutAll: arguments printString;
		nextPutAll: ')'! !

!PGFunctionCall methodsFor: 'private-initialize' stamp: 'yj 4/24/2003 23:01'!
setOid: anInteger arguments: anArray

	oid := anInteger.
	arguments := anArray! !

!PGFunctionCall methodsFor: 'printing' stamp: 'yj 11/12/2004 18:18'!
writeOn: aStream

	self writeByte: $F on: aStream.
	self writeString: '' on: aStream.
	self writeInt32: self oid on: aStream.
	self writeInt32: self arguments size on: aStream.
	self arguments do: [:arg |
		self writeInt32: arg size on: aStream.
		arg do: [:b | self writeByte: (Character value: b) on: aStream].
	]! !

PGPacket subclass: #PGFunctionResultResponse
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGFunctionResultResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#FunctionResultResponse! !

!PGFunctionResultResponse methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'result='; nextPutAll: result printString;
		nextPutAll: ')'! !

!PGFunctionResultResponse methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
receiveFrom: connection

	| emptyFlag resultSize |
	emptyFlag := connection next codePoint.
	emptyFlag == 71  "$G codePoint == 71 indicates non-void response"
		ifTrue: [
			resultSize := self readInt32From: connection.
			result := ByteArray new: resultSize.
			1 to: resultSize do: [:i | result at: i put: connection next codePoint].
			connection next. "toss the extra 0 byte"
	].
! !

!PGFunctionResultResponse methodsFor: 'accessing' stamp: 'yj 11/10/2004 23:07'!
result

	^result! !

PGPacket subclass: #PGNotificationResponse
	instanceVariableNames: 'processId conditionName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGNotificationResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
conditionName
	"Answer the value of conditionName"

	^ conditionName! !

!PGNotificationResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
conditionName: anObject
	"Set the value of conditionName"

	conditionName := anObject! !

!PGNotificationResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#NotificationResponse! !

!PGNotificationResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
processId
	"Answer the value of processId"

	^ processId! !

!PGNotificationResponse methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
processId: anObject
	"Set the value of processId"

	processId := anObject! !

!PGNotificationResponse methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
receiveFrom: connection

	processId := self readInt32From: connection.
	conditionName := self readStringFrom: connection.
! !

!PGPacket class methodsFor: 'initialize-release' stamp: 'yj 11/12/2004 18:04'!
initialize
	"PGPacket initialize"

	PacketClasses := IdentityDictionary new
		at: $K put: PGBackendKeyData;
		at: $R put: PGAuthentication;
		at: $C put: PGCompletedResponse;
		at: $G put: PGCopyInResponse;
		at: $H put: PGCopyOutResponse;
		at: $P put: PGCursorResponse;
		at: $I put: PGEmptyQueryResponse;
		at: $E put: PGErrorResponse;
		at: $V put: PGFunctionResultResponse;
		at: $N put: PGNoticeResponse;
		at: $A put: PGNotificationResponse;
		at: $Z put: PGReadyForQuery;
		at: $T put: PGRowDescription;
		at: $D put: PGAsciiRow;
		at: $B put: PGBinaryRow;
		yourself! !

!PGPacket class methodsFor: 'factory' stamp: 'yj 11/12/2004 18:12'!
newPacket: typeCode
	| packetClass |

	packetClass := PacketClasses at: typeCode ifAbsent: [nil].
	^packetClass isNil
		ifTrue: [nil]
		ifFalse: [packetClass new]! !

!PGPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^self subclassResponsibility! !

!PGPacket methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	aStream nextPutAll: self class name.
! !

!PGPacket methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
readBitmap: nbits from: connection

	| nbytes bitmap |

	nbytes := (nbits + 7) // 8.
	bitmap := ByteArray new: nbytes.
	1 to: nbytes do: [:i |
		bitmap at: i put: connection next codePoint.
	].
	^bitmap
! !

!PGPacket methodsFor: 'receiving' stamp: 'yj 1/31/2006 18:15'!
readByteN: n from: connection

	| bytes |

	bytes := ByteArray new: n.
	1 to: n do: [:i | bytes byteAt: i put: connection next codePoint].
	^bytes! !

!PGPacket methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
readFieldFrom: connection

	| n tmp |

	n := (self readInt32From: connection) - 4.
	tmp := WriteStream on: String new.
	1 to: n do: [:i |
		tmp nextPut: connection next.
	].
	^tmp contents
! !

!PGPacket methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
readInt16From: connection

	| value |

	value := connection next codePoint.
	value := (value bitShift: 8) bitOr: connection next codePoint.
	^value
! !

!PGPacket methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
readInt32From: connection

	| value |

	value := connection next codePoint.
	value := (value bitShift: 8) bitOr: connection next codePoint.
	value := (value bitShift: 8) bitOr: connection next codePoint.
	value := (value bitShift: 8) bitOr: connection next codePoint.
	^value
! !

!PGPacket methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
readStringFrom: connection

	| tmp ch |
	tmp := WriteStream on: String new.
	[ (ch := connection next) codePoint ~= 0 ] whileTrue: [
		tmp nextPut: ch.
	].
	^tmp contents

! !

!PGPacket methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
receiveFrom: connection

	"Read nothing, by default"
! !

!PGPacket methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeByte: aCharacter on: aStream

	aStream
		nextPut: aCharacter;
		yourself.

! !

!PGPacket methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeInt16: anInteger on: aStream

	aStream
		nextPut: (Character value: ((anInteger bitShift: -1*8) bitAnd: 16rFF));
		nextPut: (Character value: ((anInteger bitShift: 0*8) bitAnd: 16rFF));
		yourself.
! !

!PGPacket methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeInt32: anInteger on: aStream

	aStream
		nextPut: (Character value: ((anInteger bitShift: -3*8) bitAnd: 16rFF));
		nextPut: (Character value: ((anInteger bitShift: -2*8) bitAnd: 16rFF));
		nextPut: (Character value: ((anInteger bitShift: -1*8) bitAnd: 16rFF));
		nextPut: (Character value: ((anInteger bitShift: 0*8) bitAnd: 16rFF));
		yourself.
! !

!PGPacket methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeLimString: aString size: size on: aStream

	aString isNil ifTrue: [
		size timesRepeat: [ aStream nextPut: (Character value: 0) ].
		^aStream.
	].

	aString size < size
		ifTrue: [
			aStream nextPutAll: aString.
			(size - aString size max: 0) timesRepeat: [ aStream nextPut: (Character value: 0) ].
		]
		ifFalse: [
			aStream nextPutAll: (aString copyFrom: 1 to: size).
		].

	^aStream.
! !

!PGPacket methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeOn: aStream

	self subclassResponsiblity
! !

!PGPacket methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeString: aString on: aStream

	aStream
		nextPutAll: aString;
		nextPut: (Character value: 0);
		yourself.

! !

PGPacket subclass: #PGPasswordPacket
	instanceVariableNames: 'password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGPasswordPacket class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
password: aString

	^self new
		password: aString;
		yourself.
! !

!PGPasswordPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
password
	^password! !

!PGPasswordPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
password: aString
	password := aString! !

!PGPasswordPacket methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'password='; nextPutAll: password printString;
		nextPutAll: ')'! !

!PGPasswordPacket methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeOn: aStream

	"Add 5 for the 32bit size header, and add 1 for the '\0' after the string"

	self writeInt32: self password size + 5 on: aStream.
	self writeString: self password on: aStream.
! !

PGPacket subclass: #PGQuery
	instanceVariableNames: 'queryString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGQuery class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
sql: aString

	^self new
		queryString: aString;
		yourself.
! !

!PGQuery methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#Query! !

!PGQuery methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'queryString='; nextPutAll: queryString printString;
		nextPutAll: ')'! !

!PGQuery methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
queryString
	^queryString! !

!PGQuery methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
queryString: aString
	queryString := aString! !

!PGQuery methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeOn: aStream

	self writeByte: $Q on: aStream.
	self writeString: self queryString on: aStream.
! !

PGPacket subclass: #PGReadyForQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGReadyForQuery methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#ReadyForQuery! !

PGPacket subclass: #PGRowDescription
	instanceVariableNames: 'resultSet numberOfColumns columnDescriptions columnDescriptionDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGRowDescription class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
new

	^self basicNew initialize.
! !

!PGRowDescription methodsFor: 'as yet unclassified' stamp: 'kb 10/30/2008 16:39'!
columnDescriptionDictionary

	^columnDescriptionDictionary ifNil: [
		columnDescriptionDictionary := IdentityDictionary new.
		columnDescriptions doWithIndex: [ :each :i |
			columnDescriptionDictionary at: each fieldName asSymbol put: i ].
		columnDescriptionDictionary ]! !

!PGRowDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
columnDescriptions
	^ columnDescriptions! !

!PGRowDescription methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
displayOn: aStream

	columnDescriptions withIndexDo: [:each :i |
		each displayOn: aStream.
		i < columnDescriptions size ifTrue: [aStream space].
	].
! !

!PGRowDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
eventName
	^#RowDescription! !

!PGRowDescription methodsFor: 'initialize' stamp: 'yj 4/24/2003 23:01'!
initialize

	numberOfColumns := 0.
	columnDescriptions := OrderedCollection new.
! !

!PGRowDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
numberOfColumns
	^numberOfColumns! !

!PGRowDescription methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '('; cr.
	columnDescriptions do: [:each | each printOn: aStream. aStream cr].
	aStream nextPutAll: ')'.
! !

!PGRowDescription methodsFor: 'receiving' stamp: 'yj 4/24/2003 23:01'!
receiveFrom: connection

	numberOfColumns := self readInt16From: connection.
	1 to: numberOfColumns do: [:i |
		columnDescriptions add: (PGColumnDescription new receiveFrom: connection; yourself).
	].
! !

!PGRowDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
resultSet
	^ resultSet! !

!PGRowDescription methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
resultSet: anObject
	resultSet := anObject! !

PGPacket subclass: #PGStartupPacket
	instanceVariableNames: 'version databaseName userName extraArgs debugTty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGStartupPacket class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
databaseName: database userName: user

	^self new
		setDatabaseName: database userName: user;
		yourself! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
byteCount
	^296
! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
databaseName
	^databaseName
! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
databaseName: aString
	databaseName := aString
! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
debugTty
	^debugTty! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
debugTty: aString
	debugTty := aString! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
extraArgs
	^extraArgs! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
extraArgs: aString
	extraArgs := aString! !

!PGStartupPacket methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
printOn: aStream

	super printOn: aStream.
	aStream
		nextPutAll: '(';
		nextPutAll: 'databaseName='; nextPutAll: databaseName printString;
		nextPutAll: ',userName='; nextPutAll: userName printString;
		nextPutAll: ',extraArgs='; nextPutAll: extraArgs printString;
		nextPutAll: ',debugTty='; nextPutAll: debugTty printString;
		nextPutAll: ',version='; nextPutAll: version printString;
		nextPutAll: ')'
! !

!PGStartupPacket methodsFor: 'private-initialize' stamp: 'yj 4/24/2003 23:01'!
setDatabaseName: database userName: user

	^self
		version: (2 bitShift: 16); "major=2 minor=0"
		databaseName: database;
		userName: user;
		yourself! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
userName
	^userName! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
userName: aString
	userName := aString! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
version
	^version
! !

!PGStartupPacket methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
version: anInteger
	version := anInteger
! !

!PGStartupPacket methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeOn: aStream

	self writeInt32: self byteCount on: aStream.
	self writeInt32: self version on: aStream.
	self writeLimString: self databaseName size: 64 on: aStream.
	self writeLimString: self userName size: 32 on: aStream.
	self writeLimString: self extraArgs size: 64 on: aStream.
	self writeLimString: nil size: 64 on: aStream. "unused"
	self writeLimString: self debugTty size: 64 on: aStream.
! !

PGPacket subclass: #PGTerminate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGTerminate methodsFor: 'sending' stamp: 'yj 4/24/2003 23:01'!
writeOn: aStream

	self writeByte: $X on: aStream.
! !

Object subclass: #PGResult
	instanceVariableNames: 'connection resultSets errorResponse functionResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGResult class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
new
	^ self error: 'should not use'
! !

!PGResult class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
on: aConnection

	^ self basicNew initialize
		connection: aConnection;
		yourself.
! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'yj 4/24/2003 23:01'!
addResultSet

	resultSets add: (PGResultSet on: self).
! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'yj 4/24/2003 23:01'!
completedResponse

	^ self lastResultSet completedResponse! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'yj 4/24/2003 23:01'!
completedResponse: value

	self lastResultSet completedResponse: value! !

!PGResult methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
connection
	^ connection! !

!PGResult methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
connection: value
	connection := value! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'kb 2/25/2009 20:05'!
dataRows

	^ self lastResultSet ifNotNilDo: [ :rs |
		rs dataRows ]! !

!PGResult methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
displayResultOn: aStream

	errorResponse isNil ifFalse: [
		aStream nextPutAll: errorResponse value.
		aStream cr].

	resultSets do: [:each | each displayResultSetOn: aStream].
! !

!PGResult methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
errorResponse
	^ errorResponse! !

!PGResult methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
errorResponse: value
	errorResponse := value! !

!PGResult methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
functionResult
	^ functionResult! !

!PGResult methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
functionResult: value
	functionResult := value! !

!PGResult methodsFor: 'initialize' stamp: 'yj 4/24/2003 23:01'!
initialize

	resultSets := OrderedCollection new.
! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'kb 2/25/2009 20:06'!
lastResultSet

	^resultSets
		ifEmpty: [ nil ]
		ifNotEmpty: [ resultSets last ]! !

!PGResult methodsFor: 'initialize' stamp: 'yj 4/24/2003 23:01'!
reset
	"Clear the previous results in preparation to hold new query results."

	"There's an opportunity to tweak the code here for performance.
	If the result sets are cleared each time, then there's a lot of
	re-allocation. But, if the old results are just cleared, an earlier
	large result set may cause a large collection to remain in memory.
	Maybe it's just better to let GC handle it.
	"

	self errorResponse: nil.
	self functionResult: nil.
	resultSets := OrderedCollection new.
! !

!PGResult methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
resultSets
	^ resultSets! !

!PGResult methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
resultSets: value
	resultSets := value! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'yj 4/24/2003 23:01'!
rowDescription

	^ self lastResultSet rowDescription! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'yj 4/24/2003 23:01'!
rowDescription: aRowDescription

	| rs |

	rs := self lastResultSet.
	rs rowDescription: aRowDescription.
	rs result: self.
	aRowDescription resultSet: rs.
! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'yj 4/24/2003 23:01'!
rows

	^ self lastResultSet rows! !

!PGResult methodsFor: 'accessing-convenience' stamp: 'yj 4/24/2003 23:01'!
rows: value

	self lastResultSet rows: value! !

Object subclass: #PGResultSet
	instanceVariableNames: 'result completedResponse rowDescription rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostgresV2'!

!PGResultSet class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
new
	self error: 'should not use'! !

!PGResultSet class methodsFor: 'instance creation' stamp: 'yj 4/24/2003 23:01'!
on: aResult

	^ self basicNew initialize
		result: aResult;
		yourself.
! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
completedResponse
	"Answer the value of completedResponse"

	^ completedResponse! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
completedResponse: anObject
	"Set the value of completedResponse"

	completedResponse := anObject! !

!PGResultSet methodsFor: 'accessing' stamp: 'kb 12/17/2008 17:53'!
dataRows

	^rows collect: [ :e | e dataRow ]! !

!PGResultSet methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
displayResultSetOn: aStream

	completedResponse isNil ifFalse: [
		completedResponse displayOn: aStream.
		aStream cr.
	].
	rowDescription isNil ifFalse: [
		self displayRowDescriptionOn: aStream.
		aStream cr; nextPutAll: '----------'; cr.
		self displayRowsOn: aStream.
		aStream nextPut: $(.
		rows size printOn: aStream.
		aStream nextPutAll: ' row'.
		rows size > 1 ifTrue: [aStream nextPut: $s].
		aStream nextPut: $); cr; cr.
	].
! !

!PGResultSet methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
displayRowDescriptionOn: aStream

	rowDescription displayOn: aStream.
! !

!PGResultSet methodsFor: 'printing' stamp: 'yj 4/24/2003 23:01'!
displayRowsOn: aStream

	rows do: [:each | each displayOn: aStream. aStream cr.].
! !

!PGResultSet methodsFor: 'initialize' stamp: 'yj 4/24/2003 23:01'!
initialize

	rows := OrderedCollection new.! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
result
	"Answer the value of result"

	^ result! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
result: anObject
	"Set the value of result"

	result := anObject! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
rowDescription
	"Answer the value of rowDescription"

	^ rowDescription! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
rowDescription: anObject
	"Set the value of rowDescription"

	rowDescription := anObject! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
rows
	"Answer the value of rows"

	^ rows! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
rows: anObject
	"Set the value of rows"

	rows := anObject! !

!PGResultSet methodsFor: 'accessing' stamp: 'yj 4/24/2003 23:01'!
valueAt: fieldName

	| i |
	i := rowDescription columnDescriptions findFirst: [:each | each fieldName = fieldName].
	i = 0 ifTrue: [^ nil].
	rows == nil ifTrue: [^ nil].
	^ (rows at: 1) rawData at: i! !

Object subclass: #STON
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STON commentStamp: 'SvenVanCaekenberghe 5/3/2012 19:20' prior: 0!
STON implements serialization and materialization using the Smalltalk Object Notation format.
 
S y n t a x

	value
	  primitive-value
	  object-value
	  reference
	  nil
	primitive-value
	  number
	  true
	  false
	  symbol
	  string
	object-value
	  object
	  map
	  list
	object
	  classname map
	  classname list
	reference
	  @ int-index-previous-object-value
	map
	  {}
	  { members }
	members
	  pair
	  pair , members
	pair
	  string : value
	  symbol : value
	  number : value
	list
	  []
	  [ elements ]
	elements
	  value 
	  value , elements
	string
	  ''
	  ' chars '
	chars
	  char
	  char chars
	char
	  any-printable-ASCII-character-
	    except-'-"-or-\
	  \'
	  \"
	  \\
	  \/
	  \b
	  \f
	  \n
	  \r
	  \t
	  \u four-hex-digits
	symbol
	  # chars-limited
	  # ' chars '
	chars-limited
	  char-limited
	  char-limited chars-limited
	char-limited
	  a-z A-Z 0-9 - _ . /
	classname
	  uppercase-alpha-char alphanumeric-char
	number
	  int
	  int frac
	  int exp
	  int frac exp
	int
	  digit
	  digit1-9 digits 
	  - digit
	  - digit1-9 digits
	frac
	  . digits
	exp
	  e digits
	digits
	  digit
	  digit digits
	e
	  e
	  e+
	  e-
	  E
	  E+
	  E-
!

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 1/24/2012 09:39'!
fromStream: readStream
	^ (self reader on: readStream) next! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 1/24/2012 09:40'!
fromString: string
	^ self fromStream: string readStream! !

!STON classSide methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 5/15/2012 09:32'!
jsonWriter
	^ STONWriter new
		  jsonMode: true;
		  yourself! !

!STON classSide methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 09:36'!
listClass
	^ Array! !

!STON classSide methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 09:36'!
mapClass
	^ Dictionary! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 5/30/2012 22:06'!
put: object asJsonOnStream: stream
	(self jsonWriter on: stream) nextPut: object! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 5/30/2012 22:07'!
put: object asJsonOnStreamPretty: stream
	(self jsonWriter on: stream)
		prettyPrint: true; 
		nextPut: object! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 1/24/2012 09:49'!
put: object onStream: stream
	(self writer on: stream) nextPut: object! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 2/12/2012 19:30'!
put: object onStreamPretty: stream
	(self writer on: stream)
		prettyPrint: true; 
		nextPut: object! !

!STON classSide methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 09:37'!
reader
	^ STONReader new! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 5/30/2012 22:07'!
toJsonString: object
	^ String streamContents: [ :stream |
		self put: object asJsonOnStream: stream ]! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 5/30/2012 22:07'!
toJsonStringPretty: object
	^ String streamContents: [ :stream |
		self put: object asJsonOnStreamPretty: stream ]! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 1/24/2012 09:49'!
toString: object
	^ String streamContents: [ :stream |
		self put: object onStream: stream ]! !

!STON classSide methodsFor: 'convencience' stamp: 'SvenVanCaekenberghe 2/12/2012 19:30'!
toStringPretty: object
	^ String streamContents: [ :stream |
		self put: object onStreamPretty: stream ]! !

!STON classSide methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 09:37'!
writer
	^ STONWriter new! !

Object subclass: #STONReader
	instanceVariableNames: 'readStream objects classes unresolvedReferences stringStream allowComplexMapKeys stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONReader commentStamp: 'SvenVanCaekenberghe 5/29/2012 21:15' prior: 0!
STONReader materializes objects using the Smalltalk Object Notation format.

This parser is backwards compatible with standard JSON.!

!STONReader classSide methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 1/14/2012 20:25'!
on: readStream
	^ self new
		on: readStream;
		yourself! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 10/25/2012 15:24'!
allowComplexMapKeys: boolean
	allowComplexMapKeys := boolean! !

!STONReader methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 5/7/2012 13:49'!
atEnd
	^ readStream atEnd! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 20:26'!
close
	readStream ifNotNil: [
		readStream close.
		readStream := nil ]! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/6/2012 20:59'!
consumeWhitespace
	"Strip whitespaces from the input stream."

	[ readStream atEnd not and: [ readStream peek isSeparator ] ]
		whileTrue: [ readStream next ]! !

!STONReader methodsFor: 'error handling' stamp: 'SvenVanCaekenberghe 12/13/2013 16:13'!
error: aString
	| streamPosition |
	"Remain compatible with streams that don't understand #position"
	streamPosition := [ readStream position ]
		on: MessageNotUnderstood do: [ nil ].
	^ STONReaderError signal: aString streamPosition: streamPosition! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 5/7/2012 10:33'!
expectChar: character
	"Expect character and consume input and optional whitespace at the end,
	 throw an error otherwise."

	(self matchChar: character)
		ifFalse: [ self error: character asString, ' expected' ]! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 11/29/2012 14:47'!
initialize
	super initialize.
	objects := IdentityDictionary new.
	classes := IdentityDictionary new.
	allowComplexMapKeys := false.
	stack := Stack new.
	unresolvedReferences := 0! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/12/2012 19:27'!
isClassChar: char
	^ 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789' includes: char! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/12/2012 19:27'!
isClassStartChar: char
	^ 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' includes: char! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/12/2012 19:28'!
isSimpleSymbolChar: char
	^ 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_./' includes: char! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/11/2012 12:44'!
lookupClass: name
	Smalltalk globals 
		at: name 
		ifPresent: [ :class | ^ class ].
	^ classes 
		at: name 
		ifAbsentPut: [
			Object allSubclasses 
				detect: [ :class | class stonName == name ] 
				ifNone: [ self error: 'Cannot resolve class named ', name printString ] ]
	! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/3/2012 10:57'!
match: string do: block
	"Try to read and consume string and execute block if successful.
	Else do nothing (but do not back up)"

	(string allSatisfy: [ :each | readStream peekFor: each ])
		ifTrue: [ 
			self consumeWhitespace.
			block value ]! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 12/3/2012 10:54'!
matchChar: character
	"Tries to match character, consume input and 
	answer true if successful and consumes whitespace at the end."

	^ (readStream peekFor: character)
		ifTrue: [ 
			self consumeWhitespace.
			true ]
		ifFalse: [ false ]! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/18/2012 20:54'!
newReference
	| index reference |
	index := objects size + 1.
	reference := STONReference index: index.
	objects at: index put: reference.
	^ reference! !

!STONReader methodsFor: 'public' stamp: 'SvenVanCaekenberghe 4/27/2012 16:48'!
next
	| object |
	self consumeWhitespace.
	object := self parseValue.
	unresolvedReferences > 0
		ifTrue: [ self processSubObjectsOf: object ].
	^ object! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 20:26'!
on: aReadStream
	readStream := aReadStream! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 11/29/2012 15:54'!
optimizeForLargeStructures
	self class environment
		at: #FLLargeIdentityDictionary
		ifPresent: [ :identityDictionaryClass | objects := identityDictionaryClass new ].
	self class environment 
		at: #FLSimpleStackstack 
		ifPresent: [ :stackClass | stack := stackClass new ]! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 1/15/2012 21:38'!
parseCharacter
	| char |
	(char := readStream next) = $\ 
		ifFalse: [ ^ char ].
	(#( $' $" $/ $\) includes: (char := readStream next))
		ifTrue: [ ^ char ].
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/29/2012 21:12'!
parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ 
		value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 1/15/2012 11:28'!
parseCharacterHexDigit
	| digit |
	readStream atEnd ifFalse: [ 
		digit := readStream next asInteger.
		(digit between: "$0" 48 and: "$9" 57)
			ifTrue: [ ^ digit - 48 ].
		(digit between: "$A" 65 and: "$F" 70)
			ifTrue: [ ^ digit - 55 ].
		(digit between: "$a" 97 and: "$f" 102)
			ifTrue: [ ^ digit - 87 ] ].
	self error: 'hex-digit expected'! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/29/2012 21:13'!
parseClass
	| className |
	className := self stringStreamContents: [ :stream |
		[ readStream atEnd not and: [ self isClassChar: readStream peek ] ] whileTrue: [ 
			stream nextPut: readStream next ] ].
	self consumeWhitespace.
	^ self lookupClass: className asSymbol
	! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/7/2012 13:16'!
parseConstantDo: block
	"Parse and consume either true|false|nil|null and execute block 
	or else do nothing (but do not back up).
	Hand written implementation to avoid the use of #position:"
	
	(readStream peek = $t)
		ifTrue: [
			^ self match: 'true' do: [ block value: true ] ].
	(readStream peek = $f)
		ifTrue: [
			^ self match: 'false' do: [ block value: false ] ].
	(readStream peek = $n)
		ifTrue: [
			readStream next.
			(readStream peek = $i)
				ifTrue: [
					self match: 'il' do: [ block value: nil ] ].
			(readStream peek = $u)
				ifTrue: [
					self match: 'ull' do: [ block value: nil ] ] ]		
! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 2/12/2012 15:21'!
parseList
	| reference array |
	reference := self newReference.
	array := STON listClass streamContents: [ :stream |
		self parseListDo: [ :each | stream nextPut: each ] ].
	self setReference: reference to: array.
	^ array! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 5/7/2012 10:34'!
parseListDo: block
	| index |
	self expectChar: $[.
	(self matchChar: $]) 
		ifTrue: [ ^ self ].
	index := 1.
	[ readStream atEnd ] whileFalse: [
		block cull: self parseValue cull: index.
		(self matchChar: $]) 
			ifTrue: [ ^ self ].
		index := index + 1.
		self expectChar: $, ].
	self error: 'end of list expected'! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 2/12/2012 15:55'!
parseListSingleton
	| value |
	value := nil.
	self parseListDo: [ :each :index |
		index = 1 ifTrue: [ value := each ] ].
	^ value! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 2/12/2012 15:22'!
parseMap
	| map |
	map := STON mapClass new.
	self storeReference: map.
	self parseMapDo: [ :key :value |
		map at: key put: value ].
	^ map! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 10/25/2012 15:29'!
parseMapDo: block
	self expectChar: ${.
	(self matchChar: $})
		ifTrue: [ ^ self ].
	[ readStream atEnd ] whileFalse: [ | name value |
		name := self parseValue.
		(allowComplexMapKeys or: [ name isString or: [ name isNumber ] ])
			ifFalse: [ self error: 'unexpected property name type' ].
		self expectChar: $:.
		value := self parseValue.
		block value: name value: value.
		(self matchChar: $}) 
			ifTrue: [ ^ self ].
		self expectChar: $, ].
	self error: 'end of map expected'! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 12/3/2012 11:08'!
parseNumber
	| negated number |
	negated := readStream peekFor: $-.
	number := self parseNumberInteger.
	(readStream peekFor: $.)
		ifTrue: [ number := number + self parseNumberFraction ].
	((readStream peekFor: $e) or: [ readStream peekFor: $E ])
		ifTrue: [ number := number * self parseNumberExponent ].
	negated
		ifTrue: [ number := number negated ].
	self consumeWhitespace.
	^ number! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 12/3/2012 11:08'!
parseNumberExponent
	| number negated |
	number := 0.
	(negated := readStream peekFor: $-)
		ifFalse: [ readStream peekFor: $+ ].
	[ readStream atEnd not and: [ readStream peek isDigit ] ]
		whileTrue: [ number := 10 * number + readStream next digitValue ].
	negated
		ifTrue: [ number := number negated ].
	^ 10 raisedTo: number! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 1/15/2012 10:52'!
parseNumberFraction
	| number power |
	number := 0.
	power := 1.0.
	[ readStream atEnd not and: [ readStream peek isDigit ] ] whileTrue: [
		number := 10 * number + readStream next digitValue.
		power := power * 10.0 ].
	^ number / power! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/29/2012 21:13'!
parseNumberInteger
	| number |
	number := 0.
	[ readStream atEnd not and: [ readStream peek isDigit ] ] whileTrue: [ 
		number := 10 * number + readStream next digitValue ].
	^ number! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 2/12/2012 13:45'!
parseObject
	| targetClass reference object |
	targetClass := self parseClass.
	reference := self newReference.
	object := targetClass fromSton: self.
	self setReference: reference to: object.
	^ object! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 11/29/2012 08:52'!
parseReference
	| index object |
	self expectChar: $@.
	index := self parseNumberInteger.
	self consumeWhitespace.
	unresolvedReferences := unresolvedReferences + 1.
	^ STONReference index: index! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 2/29/2012 21:50'!
parseString
	^ self parseStringInternal! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/29/2012 21:12'!
parseStringInternal
	| result delimiter |
	delimiter := readStream next.
	(delimiter = $' or: [ delimiter = $" ]) 
		ifFalse: [ self error: ''' or " expected' ].
	result := self stringStreamContents: [ :stream |
		[ readStream atEnd or: [ readStream peek = delimiter ] ] whileFalse: [ 
			stream nextPut: self parseCharacter ] ].
	self expectChar: delimiter.
	^ result! !

!STONReader methodsFor: 'parsing-internal' stamp: 'SvenVanCaekenberghe 5/7/2012 10:42'!
parseSymbol
	| string |
	self expectChar: $#.
	readStream peek = $'
		ifTrue: [ ^ self parseStringInternal asSymbol ].
	string := self stringStreamContents: [ :stream |
		[ readStream atEnd not and: [ self isSimpleSymbolChar: readStream peek ] ] whileTrue: [
			stream nextPut: readStream next ] ].
	string isEmpty
		ifFalse: [ 
			self consumeWhitespace.
			^ string asSymbol ].
	self error: 'unexpected input'! !

!STONReader methodsFor: 'parsing' stamp: 'SvenVanCaekenberghe 5/7/2012 13:16'!
parseValue
	| char |
	readStream atEnd ifFalse: [ 
		(self isClassStartChar: (char := readStream peek)) 
			ifTrue: [ ^ self parseObject ].
		char = ${
			ifTrue: [ ^ self parseMap ].
		char = $[
			ifTrue: [ ^ self parseList ].
		(char = $' or: [ char = $" ])
			ifTrue: [ ^ self parseString ].
		char = $#
			ifTrue: [ ^ self parseSymbol ].
		char = $@
			ifTrue: [ ^ self parseReference ].
		(char = $- or: [ char isDigit ])
			ifTrue: [ ^ self parseNumber ].
		self parseConstantDo: [ :value | ^ value ] ].
	self error: 'invalid input'! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 11/29/2012 16:29'!
processSubObjectsOf: object
	stack push: object.
	[ stack isEmpty ]
		whileFalse: [ 
			stack pop
				stonProcessSubObjects: [ :each | 
					each isStonReference
						ifTrue: [ self resolveReference: each ]
						ifFalse: [ 
							each stonContainSubObjects
								ifTrue: [ stack push: each ]
								ifFalse: [ each ] ] ] ]! !

!STONReader methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 10/25/2012 17:37'!
reset
	unresolvedReferences := 0.
	objects removeAll! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/27/2012 16:31'!
resolveReference: reference
	^ self resolveReferenceIndex: reference index! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/18/2012 21:03'!
resolveReferenceIndex: index
	^ objects at: index! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/18/2012 21:01'!
setReference: reference to: object
	objects at: reference index put: object! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/16/2012 11:10'!
storeReference: object
	| index |
	index := objects size + 1.
	objects at: index put: object.
	^ index! !

!STONReader methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/9/2012 17:23'!
stringStreamContents: block
	stringStream ifNil: [ 
		stringStream := (String new: 32) writeStream ].
	stringStream reset.
	block value: stringStream.
	^ stringStream contents! !

Object subclass: #STONReference
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONReference commentStamp: 'SvenVanCaekenberghe 1/22/2012 20:13' prior: 0!
STONReference holds a forward reference to another object during materialization.
!

!STONReference classSide methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 1/18/2012 19:37'!
index: integer
	^ self new
		index: integer;
		yourself! !

!STONReference methodsFor: 'comparing' stamp: 'SvenVanCaekenberghe 1/18/2012 20:23'!
= anObject
	^ self class == anObject class and: [ self index = anObject index ]! !

!STONReference methodsFor: 'comparing' stamp: 'SvenVanCaekenberghe 1/18/2012 20:22'!
hash
	^ index hash! !

!STONReference methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/18/2012 19:35'!
index
	^ index! !

!STONReference methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/18/2012 19:35'!
index: integer
	index := integer! !

!STONReference methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 1/18/2012 20:22'!
isStonReference
	^ true! !

!STONReference methodsFor: 'printing' stamp: 'SvenVanCaekenberghe 11/28/2012 21:06'!
printOn: stream
	super printOn: stream.
	stream nextPut: $(; print: index; nextPut: $)! !

Object subclass: #STONStreamWriter
	instanceVariableNames: 'writer first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONStreamWriter commentStamp: '<historical>' prior: 0!
STONStreamWriter helps in streaming writing STON representations.
This is an abstract class.!

STONStreamWriter subclass: #STONListWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONListWriter commentStamp: '<historical>' prior: 0!
STONArrayWriter helps in writing array based STON representations.
!

!STONListWriter methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:03'!
add: anObject
	first ifTrue: [ first := false ] ifFalse: [ writer listElementSeparator ].
	writer nextPut: anObject! !

STONListWriter subclass: #STONShortListWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONShortListWriter commentStamp: '<historical>' prior: 0!
STONShortArrayWriter helps in writing short array based STON representations.
!

!STONShortListWriter methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 2/12/2012 15:49'!
add: anObject
	first ifTrue: [ first := false ] ifFalse: [ writer shortListElementSeparator ].
	writer nextPut: anObject! !

STONStreamWriter subclass: #STONMapWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'STON-Core'!

!STONMapWriter commentStamp: '<historical>' prior: 0!
STONDictionaryWriter helps in writing dictionary based STON representations.!

!STONMapWriter methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:03'!
at: key put: value
	first ifTrue: [ first := false ] ifFalse: [ writer mapElementSeparator ].
	writer encodeKey: key value: value! !

!STONStreamWriter classSide methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 1/24/2012 09:29'!
on: stonWriter
	^ self new
		on: stonWriter;
		yourself! !

!STONStreamWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/24/2012 09:30'!
initialize
	super initialize.
	first := true! !

!STONStreamWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/24/2012 09:29'!
on: stonWriter
	writer := stonWriter! !

Object subclass: #STONWriter
	instanceVariableNames: 'writeStream prettyPrint newLine jsonMode referencePolicy level objects'
	classVariableNames: 'STONCharacters STONSimpleSymbolCharacters'
	poolDictionaries: ''
	category: 'STON-Core'!

!STONWriter commentStamp: 'SvenVanCaekenberghe 4/27/2012 14:08' prior: 0!
STONWriter serializes objects using the Smalltalk Object Notation format. 

Customization options are:

- prettyPrint <Boolean> default is false
	if true, produce pretty printed output
- jsonMode <Boolean> default is false
	if true, the follow changes occur
	- strings are delimited with double quotes
	- nil is encoded as null
	- symbols are treated as strings
	- only STON listClass and STON mapClass instances are allowed as composite objects
	it is wise to also use either #error or #ignore as referencePolicy to avoid references
- referencePolicy <#normal|#ignore|#error> default is #normal
	if #normal, track and count object references and use references to implement sharing and break cycles
	if #error, track object references and signal STONWriterError when a shared reference is encountered
	if #ignore, don't track object references which might loop forever on cycles
 !

!STONWriter classSide methodsFor: 'class initialization' stamp: 'SvenVanCaekenberghe 2/9/2012 16:43'!
initialize
	self initializeSTONCharacters.
	self initializeSTONSimpleSymbolCharacters! !

!STONWriter classSide methodsFor: 'class initialization' stamp: 'SvenVanCaekenberghe 1/14/2012 23:20'!
initializeSTONCharacters
	| escapes |
	STONCharacters := Array new: 127.
	32 to: 126 do: [ :each | 
		STONCharacters at: each + 1 put: #pass ].
	escapes := #( 8 '\b' 9 '\t' 10 '\n' 12 '\f' 13 '\r' 34 '\"' 39 '\''' 92 '\\' ).
	1 to: escapes size - 1 by: 2 do: [ :index | 
		STONCharacters 
			at: (escapes at: index) + 1
			put: (escapes at: index + 1) ]
	! !

!STONWriter classSide methodsFor: 'class initialization' stamp: 'SvenVanCaekenberghe 2/14/2012 17:50'!
initializeSTONSimpleSymbolCharacters
	"STONSimpleSymbolCharacters asArray collectWithIndex: [ :each :index |
		each isZero ifTrue: [ (index - 1) asCharacter ] ]."
		
	STONSimpleSymbolCharacters := ByteArray new: 256 withAll: 1.
	1 to: 256 do: [ :each | | char |
		char := (each - 1) asCharacter.
		(self isSimpleSymbolChar: char)
			ifTrue: [ 
				STONSimpleSymbolCharacters at: each put: 0 ] ]! !

!STONWriter classSide methodsFor: 'private' stamp: 'SvenVanCaekenberghe 2/14/2012 17:49'!
isSimpleSymbolChar: char
	^ 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_./' includes: char! !

!STONWriter classSide methodsFor: 'instance creation' stamp: 'SvenVanCaekenberghe 1/14/2012 15:48'!
on: writeStream
	^ self new
		on: writeStream;
		yourself! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 15:37'!
close
	writeStream ifNotNil: [
		writeStream close.
		writeStream := nil ]! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
encodeCharacter: char
	| code encoding |
	((code := char codePoint) < 127 and: [ (encoding := STONCharacters at: code + 1) notNil ])
		ifTrue: [ 
			encoding = #pass
				ifTrue: [ writeStream nextPut: char ]
				ifFalse: [ writeStream nextPutAll: encoding ] ]
		ifFalse: [ 
			writeStream nextPutAll: '\u'.
			code printOn: writeStream base: 16 nDigits: 4 ]
! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/23/2012 11:32'!
encodeKey: key value: value
	self nextPut: key.
	self prettyPrintSpace.
	writeStream nextPut: $:.
	self prettyPrintSpace.
	self nextPut: value! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 5/5/2012 16:56'!
encodeList: elements
	writeStream nextPut: $[.
	elements isEmpty
		ifTrue: [
			self prettyPrintSpace ]
		ifFalse: [
			self indentedDo: [
				self newlineIndent.
				elements 
					do: [ :each | self nextPut: each ]
					separatedBy: [ self listElementSeparator ] ].
			self newlineIndent ].
	writeStream nextPut: $]
! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 5/5/2012 16:56'!
encodeMap: pairs
	| first |
	first := true.
	writeStream nextPut: ${.
	pairs isEmpty
		ifTrue: [
			self prettyPrintSpace ]
		ifFalse: [
			self indentedDo: [
				self newlineIndent.
				pairs keysAndValuesDo: [ :key :value |
					first 
						ifTrue: [ first := false ] 
						ifFalse: [ self mapElementSeparator ].
					self encodeKey: key value: value ] ].
			self newlineIndent ].
	writeStream nextPut: $}! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/27/2012 13:49'!
encodeString: string
	writeStream nextPut: (jsonMode ifTrue: [ $" ] ifFalse: [ $' ]).
	string do: [ :each |
		self encodeCharacter: each ].
	writeStream nextPut: (jsonMode ifTrue: [ $" ] ifFalse: [ $' ]).! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/23/2012 11:12'!
indentedDo: block
	level := level + 1.
	block value.
	level := level - 1! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 3/7/2013 10:38'!
initialize
	super initialize.
	prettyPrint := false.
	newLine := String cr.
	level := 0.
	referencePolicy := #normal.
	jsonMode := false.
	objects := IdentityDictionary new! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/15/2014 13:35'!
isSimpleSymbol: symbol
	symbol isEmpty ifTrue: [ ^ false ].
	^ (symbol class 
		findFirstInString: symbol 
		inSet: STONSimpleSymbolCharacters 
		startingAt: 1) = 0
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 4/27/2012 13:53'!
jsonMode: boolean
	jsonMode := boolean! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
listElementSeparator
	writeStream nextPut: $,.
	self newlineIndent
! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
mapElementSeparator
	writeStream nextPut: $,.
	self newlineIndent
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 3/7/2013 10:46'!
newLine: string
	newLine := string! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 3/7/2013 10:39'!
newlineIndent
	prettyPrint ifTrue: [ 
		writeStream nextPutAll: newLine.
		level timesRepeat: [ writeStream tab ] ]! !

!STONWriter methodsFor: 'public' stamp: 'SvenVanCaekenberghe 1/14/2012 15:47'!
nextPut: anObject
	anObject stonOn: self! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
on: aWriteStream
	writeStream := aWriteStream
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 11/29/2012 15:54'!
optimizeForLargeStructures
	self class environment
		at: #FLLargeIdentityDictionary
		ifPresent: [ :identityDictionaryClass | objects := identityDictionaryClass new ].! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 15:36'!
prettyPrint: boolean
	prettyPrint := boolean! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 1/23/2012 11:18'!
prettyPrintSpace
	prettyPrint ifTrue: [ writeStream space ]
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
referencePolicy: policy
	self assert: ( #(#normal #ignore #error) includes: policy ).
	referencePolicy := policy
! !

!STONWriter methodsFor: 'initialize-release' stamp: 'SvenVanCaekenberghe 1/14/2012 15:37'!
reset
	objects removeAll! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/29/2012 12:23:33'!
shortListElementSeparator
	writeStream nextPut: $,.
	self prettyPrintSpace
! !

!STONWriter methodsFor: 'private' stamp: 'SvenVanCaekenberghe 4/26/2012 17:18'!
with: object do: block
	| index |
	referencePolicy = #ignore 
		ifTrue: [ ^ block value ].
	(index := objects at: object ifAbsent: [ nil ]) notNil
		ifTrue: [
			referencePolicy = #error
				ifTrue: [ ^ STONWriterError signal: 'Shared reference detected' ].
			self writeReference: index ]
		ifFalse: [
			index := objects size + 1.
			objects at: object put: index.
			block value ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/14/2012 15:51'!
writeBoolean: boolean
	writeStream print: boolean! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/14/2012 16:05'!
writeFloat: float
	writeStream print: float! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/14/2012 15:48'!
writeInteger: integer
	writeStream print: integer! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:00'!
writeList: collection
	self with: collection do: [ 
		self encodeList: collection ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:01'!
writeMap: hashedCollection
	self with: hashedCollection do: [ 
		self encodeMap: hashedCollection ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 4/27/2012 13:50'!
writeNull
	jsonMode
		ifTrue: [ writeStream nextPutAll: 'null' ]
		ifFalse: [ writeStream print: nil ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 11/13/2013 23:46'!
writeObject: anObject
	| instanceVariableNames |
	(instanceVariableNames := anObject class allInstVarNames) isEmpty
		ifTrue: [ 
			self writeObject: anObject do: [ self encodeMap: #() ] ]
		ifFalse: [ 
			self writeObject: anObject streamMap: [ :dictionary | 
				instanceVariableNames do: [ :each | 
					(anObject instVarNamed: each)
						ifNotNil: [ :value | 
							dictionary at: each asSymbol put: value ]
						ifNil: [ 
							anObject stonShouldWriteNilInstVars 
								ifTrue: [ dictionary at: each asSymbol put: nil ] ] ] ] ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 4/27/2012 14:01'!
writeObject: anObject do: block
	(jsonMode and: [ anObject class ~= STON listClass and: [ anObject class ~= STON mapClass ] ])
		ifTrue: [ STONWriterError signal: 'Wrong object class for JSON mode' ].
	self with: anObject do: [
		writeStream nextPutAll: anObject class stonName.
		self prettyPrintSpace.
		block value ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 2/12/2012 20:02'!
writeObject: object listSingleton: element
	self writeObject: object do: [
		writeStream nextPut: $[.
		self 
			prettyPrintSpace;
			nextPut: element;
			prettyPrintSpace.
		writeStream nextPut: $] ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:02'!
writeObject: object streamList: block
	self writeObject: object do: [ | listWriter |
		listWriter := STONListWriter on: self.
		writeStream nextPut: $[.
		self indentedDo: [
			self newlineIndent.
			block value: listWriter ].
		self newlineIndent.
		writeStream nextPut: $] ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:02'!
writeObject: object streamMap: block
	self writeObject: object do: [ | mapWriter |
		mapWriter := STONMapWriter on: self.
		writeStream nextPut: ${.
		self indentedDo: [
			self newlineIndent.
			block value: mapWriter ].
		self newlineIndent.
		writeStream nextPut: $} ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/24/2012 10:02'!
writeObject: object streamShortList: block
	self writeObject: object do: [ | listWriter |
		listWriter := STONShortListWriter on: self.
		writeStream nextPut: $[.
		self indentedDo: [
			self prettyPrintSpace.
			block value: listWriter ].
		self prettyPrintSpace.
		writeStream nextPut: $] ]! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 1/14/2012 17:29'!
writeReference: index
	writeStream
		nextPut: $@;
		print: index! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 2/29/2012 21:49'!
writeString: string
	self encodeString: string! !

!STONWriter methodsFor: 'writing' stamp: 'SvenVanCaekenberghe 4/27/2012 13:52'!
writeSymbol: symbol
	jsonMode
		ifTrue: [
			self writeString: symbol ]
		ifFalse: [
			writeStream nextPut: $#.
			(self isSimpleSymbol: symbol)
				ifTrue: [
					writeStream nextPutAll: symbol ]
				ifFalse: [
					self encodeString: symbol ] ]! !
PGPacket initialize!
STONWriter initialize!
